#include <windows.h>
#include "tlhelp32.h"
#include "imagehlp.h"

#include "oh_hook.h"
#include "oh_debug.h"

#define cPushOpCode 0x68

static LPVOID pvMaxAppAddr;

static LPVOID OthHookGetOrgFunc(LPVOID pfnOrgFunc);

static LPVOID OthHookGetOrgFunc(LPVOID pfnOrgFunc)
{
   if (pfnOrgFunc > pvMaxAppAddr)
   {
      PBYTE pb = (PBYTE)pfnOrgFunc;
      if (pb[0] == cPushOpCode)
      {
         pfnOrgFunc = *(LPVOID*)&pb[1];
      }
   }
   return pfnOrgFunc;
}

int OthHookInit(LPVOID arg)
{
  SYSTEM_INFO si;
  GetSystemInfo(&si);
  pvMaxAppAddr = si.lpMaximumApplicationAddress;

  return 0;
}

int OthHookInAllMods(LPCSTR lpDllName, LPVOID pfnOrgFunc, LPVOID pfnNewFunc,
  HMODULE hmod)
{
  HANDLE hModuleSnap;
  MODULEENTRY32 me32;
  int ret;

  pfnOrgFunc = OthHookGetOrgFunc(pfnOrgFunc);

  hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, 0);
  OH_ASSERT(hModuleSnap != INVALID_HANDLE_VALUE);

  ZeroMemory(&me32, sizeof(MODULEENTRY32));

  me32.dwSize = sizeof(MODULEENTRY32);

  if (Module32First(hModuleSnap, &me32))
  {
    do
    {
      if (me32.hModule != hmod)
      {
        ret = OthHookInOneMod(lpDllName, pfnOrgFunc, pfnNewFunc, me32.hModule);
        OH_ASSERT(ret == 0);
      }
    }
    while (Module32Next(hModuleSnap, &me32));
  }

  CloseHandle(hModuleSnap);

  return 0;
}

int OthHookInOneMod(LPCSTR lpDllName, LPVOID pfnOrgFunc, LPVOID pfnNewFunc,
  HMODULE hmod)
{
  ULONG ulSize;
  PIMAGE_IMPORT_DESCRIPTOR pImportDesc;
  PIMAGE_THUNK_DATA pThunk;

  pfnOrgFunc = OthHookGetOrgFunc(pfnOrgFunc);

  pImportDesc =
    (PIMAGE_IMPORT_DESCRIPTOR)ImageDirectoryEntryToData(hmod, TRUE,
      IMAGE_DIRECTORY_ENTRY_IMPORT, &ulSize);

  if (pImportDesc == NULL)
    return 0;

  for (; pImportDesc->Name; pImportDesc++)
  {
    PSTR pszModName = (PSTR)((PBYTE)hmod + pImportDesc->Name);
    if (lstrcmpiA(pszModName, lpDllName) == 0)
      break;
  }

  if (pImportDesc->Name == 0)
    return 0;

  pThunk = (PIMAGE_THUNK_DATA)((unsigned int)hmod +
    (unsigned int)pImportDesc->FirstThunk);

  for (; pThunk->u1.Function; pThunk++)
  {
    LPVOID *ppfn = (LPVOID *)&pThunk->u1.Function;
    BOOL fFound = (*ppfn == pfnOrgFunc);

    if (!fFound && (*ppfn > pvMaxAppAddr))
    {
       PBYTE pbInFunc = (PBYTE)*ppfn;
       if (pbInFunc[0] == cPushOpCode)
       {
          ppfn = (LPVOID *)&pbInFunc[1];
          fFound = (*ppfn == pfnOrgFunc);
       }
    }

    if (fFound)
    {
      BOOL ret;
      DWORD dwDummy;

      VirtualProtect(ppfn, sizeof(ppfn), PAGE_EXECUTE_READWRITE, &dwDummy);
      ret = WriteProcessMemory(GetCurrentProcess(), ppfn, &pfnNewFunc,
        sizeof(pfnNewFunc), NULL);
      OH_ASSERT(ret);
      return 0;
    }
  }

  return 0;
}
