#include <windows.h>
#include <malloc.h>

#include "oh_txthk.h"
#include "oh_hook.h"
#include "oh_othmn.h"

#include "oh_debug.h"

static BOOL WINAPI HookCopyFileA(LPCSTR lpExistingFileName,
  LPCSTR lpNewFileName, BOOL bFailIfExists);
static BOOL WINAPI HookCreateDirectoryA(LPCSTR lpPathName,
  LPSECURITY_ATTRIBUTES lpSecurityAttributes);
static BOOL WINAPI HookCreateDirectoryExA(LPCSTR lpTemplateDirectory,
  LPCSTR lpNewDirectory, LPSECURITY_ATTRIBUTES lpSecurityAttributes);
static HANDLE WINAPI HookCreateFileA(LPCSTR lpFileName, DWORD dwDesiredAccess,
  DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes,
  DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes,
  HANDLE hTemplateFile);
static BOOL WINAPI HookDefineDosDeviceA(DWORD dwFlags, LPCSTR lpDeviceName,
  LPCSTR lpTargetPath);
static BOOL WINAPI HookDeleteFileA(LPCSTR lpFileName);
static HANDLE WINAPI HookFindFirstChangeNotificationA(LPCSTR lpPathName,
  BOOL bWatchSubtree, DWORD dwNotifyFilter);
static HANDLE WINAPI HookFindFirstFileA(LPCSTR lpFileName,
  LPWIN32_FIND_DATAA lpFindFileData);
static BOOL WINAPI HookFindNextFileA(HANDLE hFindFile,
  LPWIN32_FIND_DATAA lpFindFileData);
/*static BOOL WINAPI HookGetBinaryTypeA(LPCSTR lpApplicationName,
  LPDWORD lpBinaryType);*/
static DWORD WINAPI HookGetCurrentDirectoryA(DWORD nBufferLength,
  LPSTR lpBuffer);
static BOOL WINAPI HookGetDiskFreeSpaceA(LPCSTR lpRootPathName,
  LPDWORD lpSectorsPerCluster, LPDWORD lpBytesPerSector,
  LPDWORD lpNumberOfFreeClusters, LPDWORD lpTotalNumberOfClusters);
static BOOL WINAPI HookGetDiskFreeSpaceExA(LPCSTR lpDirectoryName,
  PULARGE_INTEGER lpFreeBytesAvailable, PULARGE_INTEGER lpTotalNumberOfBytes,
  PULARGE_INTEGER lpTotalNumberOfFreeBytes);
static UINT WINAPI HookGetDriveTypeA(LPCSTR lpRootPathName);
static DWORD WINAPI HookGetFileAttributesA(LPCSTR lpFileName);
static BOOL WINAPI HookGetFileAttributesExA(LPCSTR lpFileName,
  GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation);
static DWORD WINAPI HookGetFullPathNameA(LPCSTR lpFileName,
  DWORD nBufferLength, LPSTR lpBuffer, LPSTR *lpFilePart);
static DWORD WINAPI HookGetLogicalDriveStringsA(DWORD nBufferLength,
  LPSTR lpBuffer);
static DWORD WINAPI HookGetLongPathNameA(LPCSTR lpszShortPath,
  LPSTR lpszLongPath, DWORD cchBuffer);
static DWORD WINAPI HookGetShortPathNameA(LPCSTR lpszLongPath,
  LPSTR lpszShortPath, DWORD cchBuffer);
static UINT WINAPI HookGetTempFileNameA(LPCSTR lpPathName,
  LPCSTR lpPrefixString, UINT uUnique, LPSTR lpTempFileName);
static DWORD WINAPI HookGetTempPathA(DWORD nBufferLength, LPSTR lpBuffer);
static BOOL WINAPI HookMoveFileA(LPCSTR lpExistingFileName,
  LPCSTR lpNewFileName);
static DWORD WINAPI HookQueryDosDeviceA(LPCSTR lpDeviceName,
  LPSTR lpTargetPath, DWORD ucchMax);
static BOOL WINAPI HookRemoveDirectoryA(LPCSTR lpPathName);
static DWORD WINAPI HookSearchPathA(LPCSTR lpPath, LPCSTR lpFileName,
  LPCSTR lpExtension, DWORD nBufferLength, LPSTR lpBuffer,
  LPSTR *lpFilePart);
static BOOL WINAPI HookSetCurrentDirectoryA(LPCSTR lpPathName);
static BOOL WINAPI HookSetFileAttributesA(LPCSTR lpFileName,
  DWORD dwFileAttributes);
static BOOL WINAPI HookSetVolumeLabelA(LPCSTR lpRootPathName,
  LPCSTR lpVolumeName);
/*
static LPSTR WINAPI HookCharLowerA(LPSTR lpsz);
static LPWSTR WINAPI HookCharLowerW(LPWSTR lpsz);
static DWORD WINAPI HookCharLowerBuffA(LPSTR lpsz, DWORD cchLength);
static DWORD WINAPI HookCharLowerBuffW(LPWSTR lpsz, DWORD cchLength);
static LPSTR WINAPI HookCharNextA(LPCSTR lpsz);
static LPWSTR WINAPI HookCharNextW(LPCWSTR lpsz);
static LPSTR WINAPI HookCharNextExA(WORD CodePage, LPCSTR lpCurrentChar,
  DWORD dwFlags);
static LPSTR WINAPI HookCharPrevA(LPCSTR lpszStart, LPCSTR lpszCurrent);
static LPWSTR WINAPI HookCharPrevW(LPCWSTR lpszStart, LPCWSTR lpszCurrent);
static LPSTR WINAPI HookCharPrevExA(WORD CodePage, LPCSTR lpStart,
  LPCSTR lpCurrentChar, DWORD dwFlags);
static BOOL WINAPI HookCharToOemA(LPCSTR lpszSrc, LPSTR lpszDst);
static BOOL WINAPI HookCharToOemW(LPCWSTR lpszSrc, LPSTR lpszDst);
static BOOL WINAPI HookCharToOemBuffA(LPCSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength);
static BOOL WINAPI HookCharToOemBuffW(LPCWSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength);
static LPSTR WINAPI HookCharUpperA(LPSTR lpsz);
static LPWSTR WINAPI HookCharUpperW(LPWSTR lpsz);
static DWORD WINAPI HookCharUpperBuffA(LPSTR lpsz, DWORD cchLength);
static DWORD WINAPI HookCharUpperBuffW(LPWSTR lpsz, DWORD cchLength);
static int WINAPI HookCompareStringA(LCID Locale, DWORD dwCmpFlags,
  LPCSTR lpString1, int cchCount1, LPCSTR lpString2, int cchCount2);
static int WINAPI HookCompareStringW(LCID Locale, DWORD dwCmpFlags,
  LPCWSTR lpString1, int cchCount1, LPCWSTR lpString2, int cchCount2);
static int WINAPI HookFoldStringA(DWORD dwMapFlags, LPCSTR lpSrcStr,
  int cchSrc, LPSTR lpDestStr, int cchDest);
static int WINAPI HookFoldStringW(DWORD dwMapFlags, LPCWSTR lpSrcStr,
  int cchSrc, LPWSTR lpDestStr, int cchDest);

static BOOL WINAPI HookGetStringTypeA(LCID Locale, DWORD dwInfoType,
  LPCSTR lpSrcStr, int cchSrc, LPWORD lpCharType);
static BOOL WINAPI HookGetStringTypeW(LCID Locale, LPCWSTR lpSrcStr,
  int cchSrc, LPWORD lpCharType);
static BOOL WINAPI HookGetStringTypeExA(LCID Locale, DWORD dwInfoType,
  LPCSTR lpSrcStr, int cchSrc, LPWORD lpCharType);
static BOOL WINAPI HookGetStringTypeExW(LCID Locale, DWORD dwInfoType,
  LPCWSTR lpSrcStr, int cchSrc, LPWORD lpCharType);
static BOOL WINAPI HookIsCharAlphaA(CHAR ch);
static BOOL WINAPI HookIsCharAlphaW(WCHAR ch);
static BOOL WINAPI HookIsCharAlphaNumericA(CHAR ch);
static BOOL WINAPI HookIsCharAlphaNumericW(WCHAR ch);
static BOOL WINAPI HookIsCharLowerA(CHAR ch);
static BOOL WINAPI HookIsCharLowerW(WCHAR ch);
static BOOL WINAPI HookIsCharUpperA(CHAR ch);
static BOOL WINAPI HookIsCharUpperW(WCHAR ch);

static int WINAPI HookLoadStringA(HINSTANCE hInstance, UINT uID,
  LPSTR lpBuffer, int nBufferMax);
static int WINAPI HookLoadStringW(HINSTANCE hInstance, UINT uID,
  LPWSTR lpBuffer, int nBufferMax);
static BOOL WINAPI HookOemToCharA(LPCSTR lpszSrc, LPSTR lpszDst);
static BOOL WINAPI HookOemToCharW(LPCSTR lpszSrc, LPWSTR lpszDst);
static BOOL WINAPI HookOemToCharBuffA(LPCSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength);
static BOOL WINAPI HookOemToCharBuffW(LPCSTR lpszSrc, LPWSTR lpszDst,
  DWORD cchDstLength);
*/
static HFONT WINAPI HookCreateFontA(int nHeight, int nWidth, int nEscapement,
  int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline,
  DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision,
  DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily,
  LPCSTR lpszFace);
static int WINAPI HookEnumFontsA(HDC hdc, LPCSTR lpFaceName,
  FONTENUMPROCA lpFontFunc, LPARAM lParam);
static int WINAPI HookEnumFontsW(HDC hdc, LPCWSTR lpFaceName,
  FONTENUMPROCW lpFontFunc, LPARAM lParam);
static int WINAPI HookEnumFontFamiliesA(HDC hdc, LPCSTR lpszFamily,
  FONTENUMPROCA lpEnumFontFamProc, LPARAM lParam);
static int WINAPI HookEnumFontFamiliesW(HDC hdc, LPCWSTR lpszFamily,
  FONTENUMPROCW lpEnumFontFamProc, LPARAM lParam);
static int WINAPI HookLCMapStringA(LCID Locale, DWORD dwMapFlags,
  LPCSTR lpSrcStr, int cchSrc, LPSTR lpDestStr, int cchDest);
static int WINAPI HookLCMapStringW(LCID Locale, DWORD dwMapFlags,
  LPCWSTR lpSrcStr, int cchSrc, LPWSTR lpDestStr, int cchDest);
static BOOL WINAPI HookGetCPInfoExA(UINT CodePage, DWORD dwFlags,
  LPCPINFOEXA lpCPInfoEx);
static BOOL WINAPI HookGetCPInfoExW(UINT CodePage, DWORD dwFlags,
  LPCPINFOEXW lpCPInfoEx);
static BOOL WINAPI HookGetCPInfo(UINT CodePage, LPCPINFO lpCPInfo);
static UINT WINAPI HookGetOEMCP(void);
static UINT WINAPI HookGetACP(void);
static BOOL WINAPI HookGetCharWidthA(HDC hdc, UINT iFirstChar, UINT iLastChar,
  LPINT lpBuffer);
static BOOL WINAPI HookGetCharWidthW(HDC hdc, UINT iFirstChar, UINT iLastChar,
  LPINT lpBuffer);
static BOOL WINAPI HookGetTextExtentPointA(HDC hdc, LPCSTR lpString,
  int cbString, LPSIZE lpSize);
static BOOL WINAPI HookGetTextExtentPointW(HDC hdc, LPCWSTR lpString,
  int cbString, LPSIZE lpSize);
static int WINAPI HookWideCharToMultiByte(UINT CodePage, DWORD dwFlags,
  LPCWSTR lpWideCharStr, int cchWideChar, LPSTR lpMultiByteStr,
  int cbMultiByte, LPCSTR lpDefaultChar, LPBOOL lpUsedDefaultChar);
static int WINAPI HookMultiByteToWideChar(UINT CodePage, DWORD dwFlags,
  LPCSTR lpMultiByteStr, int cbMultiByte, LPWSTR lpWideCharStr,
  int cchWideChar);
static int WINAPI HookGetTextCharsetInfo(HDC hdc, LPFONTSIGNATURE lpSig,
  DWORD dwFlags);
static BOOL WINAPI HookIsDBCSLeadByteEx(UINT CodePage, BYTE TestChar);
static int WINAPI HookGetTextCharset(HDC hdc);
static int WINAPI HookEnumFontFamiliesExA(HDC hdc, LPLOGFONTA lpLogfont,
  FONTENUMPROCA lpEnumFontFamExProc, LPARAM lParam, DWORD dwFlags);
static int WINAPI HookEnumFontFamiliesExW(HDC hdc, LPLOGFONTW lpLogfont,
  FONTENUMPROCW lpEnumFontFamExProc, LPARAM lParam, DWORD dwFlags);
static BOOL WINAPI HookGetCharABCWidthsA(HDC hdc, UINT uFirstChar,
  UINT uLastChar, LPABC lpabc);
static BOOL WINAPI HookGetCharABCWidthsW(HDC hdc, UINT uFirstChar,
  UINT uLastChar, LPABC lpabc);
static BOOL WINAPI HookGetCharABCWidthsFloatA(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPABCFLOAT lpABCF);
static BOOL WINAPI HookGetCharABCWidthsFloatW(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPABCFLOAT lpABCF);
static DWORD WINAPI HookGetCharacterPlacementA(HDC hdc, LPCSTR lpString,
  int nCount, int nMaxExtent, LPGCP_RESULTSA lpResults, DWORD dwFlags);
static DWORD WINAPI HookGetCharacterPlacementW(HDC hdc, LPCWSTR lpString,
  int nCount, int nMaxExtent, LPGCP_RESULTSW lpResults, DWORD dwFlags);
/*
static BOOL WINAPI HookGetCharWidth32A(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPINT lpBuffer);
static BOOL WINAPI HookGetCharWidth32W(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPINT lpBuffer);*/
static BOOL WINAPI HookGetCharWidthFloatA(HDC hdc, UINT iFirstChar,
  UINT iLastChar, PFLOAT pxBuffer);
static BOOL WINAPI HookGetCharWidthFloatW(HDC hdc, UINT iFirstChar,
  UINT iLastChar, PFLOAT pxBuffer);
static DWORD WINAPI HookGetFontData(HDC hdc, DWORD dwTable, DWORD dwOffset,
  LPVOID lpvBuffer, DWORD cbData);
static DWORD WINAPI HookGetFontLanguageInfo(HDC hdc);
static DWORD WINAPI HookGetGlyphOutlineA(HDC hdc, UINT uChar, UINT uFormat,
  LPGLYPHMETRICS lpgm, DWORD cbBuffer, LPVOID lpvBuffer, CONST MAT2 *lpmat2);
static DWORD WINAPI HookGetGlyphOutlineW(HDC hdc, UINT uChar, UINT uFormat,
  LPGLYPHMETRICS lpgm, DWORD cbBuffer, LPVOID lpvBuffer, CONST MAT2 *lpmat2);
static DWORD WINAPI HookGetKerningPairsA(HDC hdc, DWORD nNumPairs,
  LPKERNINGPAIR lpkrnpair);
static DWORD WINAPI HookGetKerningPairsW(HDC hdc, DWORD nNumPairs,
  LPKERNINGPAIR lpkrnpair);
static UINT WINAPI HookGetOutlineTextMetricsA(HDC hdc, UINT cbData,
  LPOUTLINETEXTMETRICA lpOTM);
static UINT WINAPI HookGetOutlineTextMetricsW(HDC hdc, UINT cbData,
  LPOUTLINETEXTMETRICW lpOTM);
static DWORD WINAPI HookGetTabbedTextExtentA(HDC hdc, LPCSTR lpString,
  int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions);
static DWORD WINAPI HookGetTabbedTextExtentW(HDC hdc, LPCWSTR lpString,
  int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions);
static UINT WINAPI HookGetTextAlign(HDC hdc);
static int WINAPI HookGetTextCharacterExtra(HDC hdc);
static COLORREF WINAPI HookGetTextColor(HDC hdc);
static BOOL WINAPI HookGetTextExtentExPointA(HDC hdc, LPCSTR lpszStr,
  int cchString, int nMaxExtent, LPINT lpnFit, LPINT alpDx, LPSIZE lpSize);
static BOOL WINAPI HookGetTextExtentExPointW(HDC hdc, LPCWSTR lpszStr,
  int cchString, int nMaxExtent, LPINT lpnFit, LPINT alpDx, LPSIZE lpSize);
static BOOL WINAPI HookGetTextExtentPoint32A(HDC hdc, LPCSTR lpString,
  int cbString, LPSIZE lpSize);
static BOOL WINAPI HookGetTextExtentPoint32W(HDC hdc, LPCWSTR lpString,
  int cbString, LPSIZE lpSize);
static int WINAPI HookGetTextFaceA(HDC hdc, int nCount, LPSTR lpFaceName);
static int WINAPI HookGetTextFaceW(HDC hdc, int nCount, LPWSTR lpFaceName);
static BOOL WINAPI HookGetTextMetricsA(HDC hdc, LPTEXTMETRICA lptm);
static BOOL WINAPI HookGetTextMetricsW(HDC hdc, LPTEXTMETRICW lptm);
static DWORD WINAPI HookSetMapperFlags(HDC hdc, DWORD dwFlag);
static UINT WINAPI HookSetTextAlign(HDC hdc, UINT fMode);
static int WINAPI HookSetTextCharacterExtra(HDC hdc, int nCharExtra);
static COLORREF WINAPI HookSetTextColor(HDC hdc, COLORREF crColor);
static BOOL WINAPI HookSetTextJustification(HDC hdc, int nBreakExtra,
  int nBreakCount);
static BOOL WINAPI HookTextOutA(HDC hdc, int nXStart, int nYStart,
  LPCSTR lpString, int cbString);
static BOOL WINAPI HookTextOutW(HDC hdc, int nXStart, int nYStart,
  LPCWSTR lpString, int cbString);
static BOOL WINAPI HookExtTextOutA(HDC hdc, int X, int Y, UINT fuOptions,
  CONST RECT *lprc, LPCSTR lpString, UINT cbCount, CONST INT *lpDx);
static BOOL WINAPI HookExtTextOutW(HDC hdc, int X, int Y, UINT fuOptions,
  CONST RECT *lprc, LPCWSTR lpString, UINT cbCount, CONST INT *lpDx);
/*static BOOL WINAPI HookPolyTextOutA(HDC hdc, CONST POLYTEXTA *pptxt,
  int cStrings);
static BOOL WINAPI HookPolyTextOutW(HDC hdc, CONST POLYTEXTW *pptxt,
  int cStrings);*/
static LONG WINAPI HookTabbedTextOutA(HDC hdc, int X, int Y,
  LPCSTR lpString, int nCount, int nTabPositions,
  CONST LPINT lpnTabStopPositions, int nTabOrigin);
static LONG WINAPI HookTabbedTextOutW(HDC hdc, int X, int Y,
  LPCWSTR lpString, int nCount, int nTabPositions,
  CONST LPINT lpnTabStopPositions, int nTabOrigin);
static int WINAPI HookDrawTextA(HDC hdc, LPCSTR lpString, int nCount,
  LPRECT lpRect, UINT uFormat);
static int WINAPI HookDrawTextW(HDC hdc, LPCWSTR lpString, int nCount,
  LPRECT lpRect, UINT uFormat);
static int WINAPI HookDrawTextExA(HDC hdc, LPSTR lpchText, int cchText,
  LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams);
static int WINAPI HookDrawTextExW(HDC hdc, LPWSTR lpchText, int cchText,
  LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams);

static HMODULE WINAPI HookLoadLibraryA(LPCSTR lpFileName);
static HMODULE WINAPI HookLoadLibraryW(LPCWSTR lpFileName);
static HMODULE WINAPI HookLoadLibraryExA(LPCSTR lpFileName, HANDLE hFile,
  DWORD dwFlags);
static HMODULE WINAPI HookLoadLibraryExW(LPCWSTR lpFileName, HANDLE hFile,
  DWORD dwFlags);
static FARPROC WINAPI HookGetProcAddress(HMODULE hModule,
  LPCSTR lpProcName);

static int HookInNewModule(HMODULE hmod, DWORD dwFlags);

static LPSTR Uni2Ansi(LPCWSTR str);
static void Uni2AnsiBuff(LPCWSTR str1, LPSTR str2, int str2len);
static void FreeAnsi(LPSTR str);
static LPWSTR Ansi2Uni(LPCSTR str);
static void Ansi2UniBuff(LPCSTR str1, LPWSTR str2, int str2len);
static void FreeUni(LPWSTR str);

static LPSTR ENG2JPFontName(LPCSTR ENGFontName);
static LPSTR JP2ENGFontName(LPCSTR JPFontName);

typedef struct HOOKITEM
{
  LPCSTR lpDllName;
  LPCSTR lpOrgFuncName;
  PVOID pfnNewFunc;
  PVOID pfnOrgFunc;
} HOOKITEM;

static HOOKITEM HookList[] =
  {
    {"kernel32.dll", "CopyFileA", (PVOID)HookCopyFileA, NULL},
    {"kernel32.dll", "CreateDirectoryA", (PVOID)HookCreateDirectoryA, NULL},
    {"kernel32.dll", "CreateDirectoryExA", (PVOID)HookCreateDirectoryExA,
      NULL},
    {"kernel32.dll", "CreateFileA", (PVOID)HookCreateFileA, NULL},
    {"kernel32.dll", "DefineDosDeviceA", (PVOID)HookDefineDosDeviceA, NULL},
    {"kernel32.dll", "DeleteFileA", (PVOID)HookDeleteFileA, NULL},
    {"kernel32.dll", "FindFirstChangeNotificationA",
      (PVOID)HookFindFirstChangeNotificationA, NULL},
    {"kernel32.dll", "FindFirstFileA", (PVOID)HookFindFirstFileA, NULL},
    {"kernel32.dll", "FindNextFileA", (PVOID)HookFindNextFileA, NULL},
/*    {"kernel32.dll", "GetBinaryTypeA", (PVOID)HookGetBinaryTypeA, NULL}, */
    {"kernel32.dll", "GetCurrentDirectoryA", (PVOID)HookGetCurrentDirectoryA,
      NULL},
    {"kernel32.dll", "GetDiskFreeSpaceA", (PVOID)HookGetDiskFreeSpaceA, NULL},
    {"kernel32.dll", "GetDiskFreeSpaceExA", (PVOID)HookGetDiskFreeSpaceExA,
      NULL},
    {"kernel32.dll", "GetDriveTypeA", (PVOID)HookGetDriveTypeA, NULL},
    {"kernel32.dll", "GetFileAttributesA", (PVOID)HookGetFileAttributesA,
      NULL},
    {"kernel32.dll", "GetFileAttributesExA", (PVOID)HookGetFileAttributesExA,
      NULL},
    {"kernel32.dll", "GetFullPathNameA", (PVOID)HookGetFullPathNameA, NULL},
    {"kernel32.dll", "GetLogicalDriveStringsA",
      (PVOID)HookGetLogicalDriveStringsA, NULL},
    {"kernel32.dll", "GetLongPathNameA", (PVOID)HookGetLongPathNameA, NULL},
    {"kernel32.dll", "GetShortPathNameA", (PVOID)HookGetShortPathNameA, NULL},
    {"kernel32.dll", "GetTempFileNameA", (PVOID)HookGetTempFileNameA, NULL},
    {"kernel32.dll", "GetTempPathA", (PVOID)HookGetTempPathA, NULL},
    {"kernel32.dll", "MoveFileA", (PVOID)HookMoveFileA, NULL},
    {"kernel32.dll", "QueryDosDeviceA", (PVOID)HookQueryDosDeviceA, NULL},
    {"kernel32.dll", "RemoveDirectoryA", (PVOID)HookRemoveDirectoryA, NULL},
    {"kernel32.dll", "SearchPathA", (PVOID)HookSearchPathA, NULL},
    {"kernel32.dll", "SetCurrentDirectoryA", (PVOID)HookSetCurrentDirectoryA,
      NULL},
    {"kernel32.dll", "SetFileAttributesA", (PVOID)HookSetFileAttributesA,
      NULL},
    {"kernel32.dll", "SetVolumeLabelA", (PVOID)HookSetVolumeLabelA, NULL},
/*    {"user32.dll", "CharLowerA", (PVOID)HookCharLowerA, NULL},
    {"user32.dll", "CharLowerW", (PVOID)HookCharLowerW, NULL},
    {"user32.dll", "CharLowerBuffA", (PVOID)HookCharLowerBuffA, NULL},
    {"user32.dll", "CharLowerBuffW", (PVOID)HookCharLowerBuffW, NULL},
    {"user32.dll", "CharNextA", (PVOID)HookCharNextA, NULL},
    {"user32.dll", "CharNextW", (PVOID)HookCharNextW, NULL},
    {"user32.dll", "CharNextExA", (PVOID)HookCharNextExA, NULL},
    {"user32.dll", "CharPrevA", (PVOID)HookCharPrevA, NULL},
    {"user32.dll", "CharPrevW", (PVOID)HookCharPrevW, NULL},
    {"user32.dll", "CharPrevExA", (PVOID)HookCharPrevExA, NULL},
    {"user32.dll", "CharToOemA", (PVOID)HookCharToOemA, NULL},
    {"user32.dll", "CharToOemW", (PVOID)HookCharToOemW, NULL},
    {"user32.dll", "CharToOemBuffA", (PVOID)HookCharToOemBuffA, NULL},
    {"user32.dll", "CharToOemBuffW", (PVOID)HookCharToOemBuffW, NULL},
    {"user32.dll", "CharUpperA", (PVOID)HookCharUpperA, NULL},
    {"user32.dll", "CharUpperW", (PVOID)HookCharUpperW, NULL},
    {"user32.dll", "CharUpperBuffA", (PVOID)HookCharUpperBuffA, NULL},
    {"user32.dll", "CharUpperBuffW", (PVOID)HookCharUpperBuffW, NULL},
    {"kernel32.dll", "CompareStringA", (PVOID)HookCompareStringA, NULL},
    {"kernel32.dll", "CompareStringW", (PVOID)HookCompareStringW, NULL},
    {"kernel32.dll", "FoldStringA", (PVOID)HookFoldStringA, NULL},
    {"kernel32.dll", "FoldStringW", (PVOID)HookFoldStringW, NULL},
    {"kernel32.dll", "GetStringTypeA", (PVOID)HookGetStringTypeA, NULL},
    {"kernel32.dll", "GetStringTypeW", (PVOID)HookGetStringTypeW, NULL},
    {"kernel32.dll", "GetStringTypeExA", (PVOID)HookGetStringTypeExA, NULL},
    {"kernel32.dll", "GetStringTypeExW", (PVOID)HookGetStringTypeExW, NULL},
    {"user32.dll", "IsCharAlphaA", (PVOID)HookIsCharAlphaA, NULL},
    {"user32.dll", "IsCharAlphaW", (PVOID)HookIsCharAlphaW, NULL},
    {"user32.dll", "IsCharAlphaNumericA", (PVOID)HookIsCharAlphaNumericA,
      NULL},
    {"user32.dll", "IsCharAlphaNumericW", (PVOID)HookIsCharAlphaNumericW,
      NULL},
    {"user32.dll", "IsCharLowerA", (PVOID)HookIsCharLowerA, NULL},
    {"user32.dll", "IsCharLowerW", (PVOID)HookIsCharLowerW, NULL},
    {"user32.dll", "IsCharUpperA", (PVOID)HookIsCharUpperA, NULL},
    {"user32.dll", "IsCharUpperW", (PVOID)HookIsCharUpperW, NULL},
    {"user32.dll", "LoadStringA", (PVOID)HookLoadStringA, NULL},
    {"user32.dll", "LoadStringW", (PVOID)HookLoadStringW, NULL},
    {"user32.dll", "OemToCharA", (PVOID)HookOemToCharA, NULL},
    {"user32.dll", "OemToCharW", (PVOID)HookOemToCharW, NULL},
    {"user32.dll", "OemToCharBuffA", (PVOID)HookOemToCharBuffA, NULL},
    {"user32.dll", "OemToCharBuffW", (PVOID)HookOemToCharBuffW, NULL},*/
    {"gdi32.dll", "CreateFontA", (PVOID)HookCreateFontA, NULL},
    {"gdi32.dll", "EnumFontsA", (PVOID)HookEnumFontsA, NULL},
    {"gdi32.dll", "EnumFontsW", (PVOID)HookEnumFontsW, NULL},
    {"gdi32.dll", "EnumFontFamiliesA", (PVOID)HookEnumFontFamiliesA, NULL},
    {"gdi32.dll", "EnumFontFamiliesW", (PVOID)HookEnumFontFamiliesW, NULL},
    {"kernel32.dll", "LCMapStringA", (PVOID)HookLCMapStringA, NULL},
    {"kernel32.dll", "LCMapStringW", (PVOID)HookLCMapStringW, NULL},
    {"kernel32.dll", "GetCPInfoExA", (PVOID)HookGetCPInfoExA, NULL},
    {"kernel32.dll", "GetCPInfoExW", (PVOID)HookGetCPInfoExW, NULL},
    {"kernel32.dll", "GetCPInfo", (PVOID)HookGetCPInfo, NULL},
    {"kernel32.dll", "GetOEMCP", (PVOID)HookGetOEMCP, NULL},
    {"kernel32.dll", "GetACP", (PVOID)HookGetACP, NULL},
    {"gdi32.dll", "GetCharWidthA", (PVOID)HookGetCharWidthA, NULL},
    {"gdi32.dll", "GetCharWidthW", (PVOID)HookGetCharWidthW, NULL},
    {"gdi32.dll", "GetTextExtentPointA", (PVOID)HookGetTextExtentPointA, NULL},
    {"gdi32.dll", "GetTextExtentPointW", (PVOID)HookGetTextExtentPointW, NULL},
    {"kernel32.dll", "WideCharToMultiByte", (PVOID)HookWideCharToMultiByte,
      NULL},
    {"kernel32.dll", "MultiByteToWideChar", (PVOID)HookMultiByteToWideChar,
      NULL},
    {"gdi32.dll", "GetTextCharset", (PVOID)HookGetTextCharset, NULL},
    {"gdi32.dll", "GetTextCharsetInfo", (PVOID)HookGetTextCharsetInfo, NULL},
    {"kernel32.dll", "IsDBCSLeadByteEx", (PVOID)HookIsDBCSLeadByteEx, NULL},
    {"gdi32.dll", "EnumFontFamiliesExA", (PVOID)HookEnumFontFamiliesExA, NULL},
    {"gdi32.dll", "EnumFontFamiliesExW", (PVOID)HookEnumFontFamiliesExW, NULL},
    {"gdi32.dll", "GetCharABCWidthsA", (PVOID)HookGetCharABCWidthsA, NULL},
    {"gdi32.dll", "GetCharABCWidthsW", (PVOID)HookGetCharABCWidthsW, NULL},
    {"gdi32.dll", "GetCharABCWidthsFloatA", (PVOID)HookGetCharABCWidthsFloatA,
      NULL},
    {"gdi32.dll", "GetCharABCWidthsFloatW", (PVOID)HookGetCharABCWidthsFloatW,
      NULL},
    {"gdi32.dll", "GetCharacterPlacementA", (PVOID)HookGetCharacterPlacementA,
      NULL},
    {"gdi32.dll", "GetCharacterPlacementW", (PVOID)HookGetCharacterPlacementW,
      NULL},
/*    {"gdi32.dll", "GetCharWidth32A", (PVOID)HookGetCharWidth32A, NULL},
    {"gdi32.dll", "GetCharWidth32W", (PVOID)HookGetCharWidth32W, NULL},*/
    {"gdi32.dll", "GetCharWidthFloatA", (PVOID)HookGetCharWidthFloatA, NULL},
    {"gdi32.dll", "GetCharWidthFloatW", (PVOID)HookGetCharWidthFloatW, NULL},
    {"gdi32.dll", "GetFontData", (PVOID)HookGetFontData, NULL},
    {"gdi32.dll", "GetFontLanguageInfo", (PVOID)HookGetFontLanguageInfo, NULL},
    {"gdi32.dll", "GetGlyphOutlineA", (PVOID)HookGetGlyphOutlineA, NULL},
    {"gdi32.dll", "GetGlyphOutlineW", (PVOID)HookGetGlyphOutlineW, NULL},
    {"gdi32.dll", "GetKerningPairsA", (PVOID)HookGetKerningPairsA, NULL},
    {"gdi32.dll", "GetKerningPairsW", (PVOID)HookGetKerningPairsW, NULL},
    {"gdi32.dll", "GetOutlineTextMetricsA", (PVOID)HookGetOutlineTextMetricsA,
      NULL},
    {"gdi32.dll", "GetOutlineTextMetricsW", (PVOID)HookGetOutlineTextMetricsW,
      NULL},
    {"user32.dll", "GetTabbedTextExtentA", (PVOID)HookGetTabbedTextExtentA,
      NULL},
    {"user32.dll", "GetTabbedTextExtentW", (PVOID)HookGetTabbedTextExtentW,
      NULL},
    {"gdi32.dll", "GetTextAlign", (PVOID)HookGetTextAlign, NULL},
    {"gdi32.dll", "GetTextCharacterExtra", (PVOID)HookGetTextCharacterExtra,
      NULL},
    {"gdi32.dll", "GetTextColor", (PVOID)HookGetTextColor, NULL},
    {"gdi32.dll", "GetTextExtentExPointA", (PVOID)HookGetTextExtentExPointA,
      NULL},
    {"gdi32.dll", "GetTextExtentExPointW", (PVOID)HookGetTextExtentExPointW,
      NULL},
    {"gdi32.dll", "GetTextExtentPoint32A", (PVOID)HookGetTextExtentPoint32A,
      NULL},
    {"gdi32.dll", "GetTextExtentPoint32W", (PVOID)HookGetTextExtentPoint32W,
      NULL},
    {"gdi32.dll", "GetTextFaceA", (PVOID)HookGetTextFaceA, NULL},
    {"gdi32.dll", "GetTextFaceW", (PVOID)HookGetTextFaceW, NULL},
    {"gdi32.dll", "GetTextMetricsA", (PVOID)HookGetTextMetricsA, NULL},
    {"gdi32.dll", "GetTextMetricsW", (PVOID)HookGetTextMetricsW, NULL},
    {"gdi32.dll", "SetMapperFlags", (PVOID)HookSetMapperFlags, NULL},
    {"gdi32.dll", "SetTextAlign", (PVOID)HookSetTextAlign, NULL},
    {"gdi32.dll", "SetTextCharacterExtra", (PVOID)HookSetTextCharacterExtra,
      NULL},
    {"gdi32.dll", "SetTextColor", (PVOID)HookSetTextColor, NULL},
    {"gdi32.dll", "SetTextJustification", (PVOID)HookSetTextJustification,
      NULL},
    {"gdi32.dll", "TextOutA", (PVOID)HookTextOutA, NULL},
    {"gdi32.dll", "TextOutW", (PVOID)HookTextOutW, NULL},
    {"gdi32.dll", "ExtTextOutA", (PVOID)HookExtTextOutA, NULL},
    {"gdi32.dll", "ExtTextOutW", (PVOID)HookExtTextOutW, NULL},
/*    {"gdi32.dll", "PolyTextOutA", (PVOID)HookPolyTextOutA, NULL},
    {"gdi32.dll", "PolyTextOutW", (PVOID)HookPolyTextOutW, NULL},*/
    {"user32.dll", "TabbedTextOutA", (PVOID)HookTabbedTextOutA, NULL},
    {"user32.dll", "TabbedTextOutW", (PVOID)HookTabbedTextOutW, NULL},
    {"user32.dll", "DrawTextA", (PVOID)HookDrawTextA, NULL},
    {"user32.dll", "DrawTextW", (PVOID)HookDrawTextW, NULL},
    {"user32.dll", "DrawTextExA", (PVOID)HookDrawTextExA, NULL},
    {"user32.dll", "DrawTextExW", (PVOID)HookDrawTextExW, NULL},
    {"kernel32.dll", "LoadLibraryA", (PVOID)HookLoadLibraryA, NULL},
    {"kernel32.dll", "LoadLibraryW", (PVOID)HookLoadLibraryW, NULL},
    {"kernel32.dll", "LoadLibraryExA", (PVOID)HookLoadLibraryExA, NULL},
    {"kernel32.dll", "LoadLibraryExW", (PVOID)HookLoadLibraryExW, NULL},
    {"kernel32.dll", "GetProcAddress", (PVOID)HookGetProcAddress, NULL}
  };

static const int HookListLen = sizeof(HookList) / sizeof(HOOKITEM);

typedef struct JPENGFONT
{
  LPSTR lpJPFontName;
  LPSTR lpENGFontName;
} JPENGFONT;

static JPENGFONT JPENGFonts[] =
  {
    {"\x82\x6c\x82\x72\x20\x96\xbe\x92\xa9", "MS Mincho"},
    {"\x40\x82\x6c\x82\x72\x20\x96\xbe\x92\xa9", "@MS Mincho"},
    {"\x82\x6c\x82\x72\x20\x82\x6f\x96\xbe\x92\xa9", "MS PMincho"},
    {"\x40\x82\x6c\x82\x72\x20\x82\x6f\x96\xbe\x92\xa9", "@MS PMincho"},
    {"\x82\x6c\x82\x72\x20\x83\x53\x83\x56\x83\x62\x83\x4e", "MS Gothic"},
    {"\x40\x82\x6c\x82\x72\x20\x83\x53\x83\x56\x83\x62\x83\x4e", "@MS Gothic"},
    {"\x82\x6c\x82\x72\x20\x82\x6f\x83\x53\x83\x56\x83\x62\x83\x4e",
      "MS PGothic"},
    {"\x40\x82\x6c\x82\x72\x20\x82\x6f\x83\x53\x83\x56\x83\x62\x83\x4e",
      "@MS PGothic"},
  };

static const int JPEngFontsLen = sizeof(JPENGFonts) / sizeof(JPENGFONT);

static BOOL WINAPI HookCopyFileA(LPCSTR lpExistingFileName,
  LPCSTR lpNewFileName, BOOL bFailIfExists)
{
  BOOL ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "CopyFileA"));

  str1 = Ansi2Uni(lpExistingFileName);
  str2 = Ansi2Uni(lpNewFileName);
  ret = CopyFileW(str1, str2, bFailIfExists);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookCreateDirectoryA(LPCSTR lpPathName,
  LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "CreateDirectoryA"));

  str1 = Ansi2Uni(lpPathName);
  ret = CreateDirectoryW(str1, lpSecurityAttributes);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookCreateDirectoryExA(LPCSTR lpTemplateDirectory,
  LPCSTR lpNewDirectory, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
  BOOL ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "CreateDirectoryExA"));

  str1 = Ansi2Uni(lpTemplateDirectory);
  str2 = Ansi2Uni(lpNewDirectory);
  ret = CreateDirectoryExW(str1, str2, lpSecurityAttributes);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static HANDLE WINAPI HookCreateFileA(LPCSTR lpFileName, DWORD dwDesiredAccess,
  DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes,
  DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes,
  HANDLE hTemplateFile)
{
  HANDLE ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "CreateFileA"));

  str1 = Ansi2Uni(lpFileName);
  ret =
    CreateFileW(str1, dwDesiredAccess, dwShareMode, lpSecurityAttributes,
      dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookDefineDosDeviceA(DWORD dwFlags, LPCSTR lpDeviceName,
  LPCSTR lpTargetPath)
{
  BOOL ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "DefineDosDeviceA"));

  str1 = Ansi2Uni(lpDeviceName);
  str2 = Ansi2Uni(lpTargetPath);
  ret = DefineDosDeviceW(dwFlags, str1, str2);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookDeleteFileA(LPCSTR lpFileName)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "DeleteFileA"));

  str1 = Ansi2Uni(lpFileName);
  ret = DeleteFileW(str1);
  FreeUni(str1);

  return ret;
}

static HANDLE WINAPI HookFindFirstChangeNotificationA(LPCSTR lpPathName,
  BOOL bWatchSubtree, DWORD dwNotifyFilter)
{
  HANDLE ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "FindFirstChangeNotificationA"));

  str1 = Ansi2Uni(lpPathName);
  ret = FindFirstChangeNotificationW(str1, bWatchSubtree, dwNotifyFilter);
  FreeUni(str1);

  return ret;
}

static HANDLE WINAPI HookFindFirstFileA(LPCSTR lpFileName,
  LPWIN32_FIND_DATAA lpFindFileData)
{
  HANDLE ret;
  LPWSTR str1;
  WIN32_FIND_DATAW data;

  oh_db_log((OL_DBG, OD_FILESYS, "FindFirstFileA"));

  str1 = Ansi2Uni(lpFileName);
  ret = FindFirstFileW(str1, &data);
  FreeUni(str1);

  lpFindFileData->dwFileAttributes = data.dwFileAttributes;
  lpFindFileData->ftCreationTime = data.ftCreationTime;
  lpFindFileData->ftLastAccessTime = data.ftLastAccessTime;
  lpFindFileData->ftLastWriteTime = data.ftLastWriteTime;
  lpFindFileData->nFileSizeHigh = data.nFileSizeHigh;
  lpFindFileData->nFileSizeLow = data.nFileSizeLow;
  lpFindFileData->dwReserved0 = data.dwReserved0;
  lpFindFileData->dwReserved1 = data.dwReserved1;
  Uni2AnsiBuff(data.cFileName, lpFindFileData->cFileName, MAX_PATH);
  Uni2AnsiBuff(data.cAlternateFileName, lpFindFileData->cAlternateFileName,
    14);

  return ret;
}

static BOOL WINAPI HookFindNextFileA(HANDLE hFindFile,
  LPWIN32_FIND_DATAA lpFindFileData)
{
  BOOL ret;
  WIN32_FIND_DATAW data;

  oh_db_log((OL_DBG, OD_FILESYS, "FindNextFileA"));

  ret = FindNextFileW(hFindFile, &data);

  lpFindFileData->dwFileAttributes = data.dwFileAttributes;
  lpFindFileData->ftCreationTime = data.ftCreationTime;
  lpFindFileData->ftLastAccessTime = data.ftLastAccessTime;
  lpFindFileData->ftLastWriteTime = data.ftLastWriteTime;
  lpFindFileData->nFileSizeHigh = data.nFileSizeHigh;
  lpFindFileData->nFileSizeLow = data.nFileSizeLow;
  lpFindFileData->dwReserved0 = data.dwReserved0;
  lpFindFileData->dwReserved1 = data.dwReserved1;
  Uni2AnsiBuff(data.cFileName, lpFindFileData->cFileName, MAX_PATH);
  Uni2AnsiBuff(data.cAlternateFileName, lpFindFileData->cAlternateFileName,
    14);

  return ret;
}

/*static BOOL WINAPI HookGetBinaryTypeA(LPCSTR lpApplicationName,
  LPDWORD lpBinaryType)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetBinaryTypeA"));

  str1 = Ansi2Uni(lpApplicationName);
  ret = GetBinaryTypeW(str1, lpBinaryType);
  FreeUni(str1);

  return ret;
}*/

static DWORD WINAPI HookGetCurrentDirectoryA(DWORD nBufferLength,
  LPSTR lpBuffer)
{
  DWORD ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetCurrentDirectoryA"));

  str1 = _alloca(nBufferLength << 1);
  ret = GetCurrentDirectoryW(nBufferLength, str1);
  Uni2AnsiBuff(str1, lpBuffer, nBufferLength);

  return ret;
}

static BOOL WINAPI HookGetDiskFreeSpaceA(LPCSTR lpRootPathName,
  LPDWORD lpSectorsPerCluster, LPDWORD lpBytesPerSector,
  LPDWORD lpNumberOfFreeClusters, LPDWORD lpTotalNumberOfClusters)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetDiskFreeSpaceA"));

  str1 = Ansi2Uni(lpRootPathName);
  ret =
    GetDiskFreeSpaceW(str1, lpSectorsPerCluster, lpBytesPerSector,
      lpNumberOfFreeClusters, lpTotalNumberOfClusters);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookGetDiskFreeSpaceExA(LPCSTR lpDirectoryName,
  PULARGE_INTEGER lpFreeBytesAvailable, PULARGE_INTEGER lpTotalNumberOfBytes,
  PULARGE_INTEGER lpTotalNumberOfFreeBytes)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetDiskFreeSpaceExA"));

  str1 = Ansi2Uni(lpDirectoryName);
  ret =
    GetDiskFreeSpaceExW(str1, lpFreeBytesAvailable, lpTotalNumberOfBytes,
      lpTotalNumberOfFreeBytes);
  FreeUni(str1);

  return ret;
}

static UINT WINAPI HookGetDriveTypeA(LPCSTR lpRootPathName)
{
  UINT ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetDriveTypeA"));

  str1 = Ansi2Uni(lpRootPathName);
  ret = GetDriveTypeW(str1);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookGetFileAttributesA(LPCSTR lpFileName)
{
  DWORD ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetFileAttributesA"));

  str1 = Ansi2Uni(lpFileName);
  ret = GetFileAttributesW(str1);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookGetFileAttributesExA(LPCSTR lpFileName,
  GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetFileAttributesExA"));

  str1 = Ansi2Uni(lpFileName);
  ret = GetFileAttributesExW(str1, fInfoLevelId, lpFileInformation);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookGetFullPathNameA(LPCSTR lpFileName,
  DWORD nBufferLength, LPSTR lpBuffer, LPSTR *lpFilePart)
{
  DWORD ret;
  LPWSTR str1;
  LPWSTR str2;
  LPWSTR str3;
  int len, i;

  oh_db_log((OL_DBG, OD_FILESYS, "GetFullPathNameA"));

  str1 = Ansi2Uni(lpFileName);
  str2 = _alloca(nBufferLength << 1);
  ret = GetFullPathNameW(str1, nBufferLength, str2, &str3);
  Uni2AnsiBuff(str2, lpBuffer, nBufferLength);
  len = lstrlenA(lpBuffer);
  for (i = len - 1; i >= 0; i--)
  {
    if (lpBuffer[i] == '\\')
    {
      *lpFilePart = &lpBuffer[i + 1];
      break;
    }
  }
  if (i < 0)
    *lpFilePart = NULL;
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookGetLogicalDriveStringsA(DWORD nBufferLength,
  LPSTR lpBuffer)
{
  DWORD ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetLogicalDriveStringsA"));

  str1 = _alloca(nBufferLength << 1);
  ret = GetLogicalDriveStringsW(nBufferLength, str1);
  Uni2AnsiBuff(str1, lpBuffer, nBufferLength);

  return ret;
}

static DWORD WINAPI HookGetLongPathNameA(LPCSTR lpszShortPath,
  LPSTR lpszLongPath, DWORD cchBuffer)
{
  DWORD ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "GetLongPathNameA"));

  str1 = Ansi2Uni(lpszShortPath);
  str2 = _alloca(cchBuffer << 1);
  ret = GetLongPathNameW(str1, str2, cchBuffer);
  Uni2AnsiBuff(str2, lpszLongPath, cchBuffer);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookGetShortPathNameA(LPCSTR lpszLongPath,
  LPSTR lpszShortPath, DWORD cchBuffer)
{
  DWORD ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "GetShortPathNameA"));

  str1 = Ansi2Uni(lpszLongPath);
  str2 = _alloca(cchBuffer << 1);
  ret = GetShortPathNameW(str1, str2, cchBuffer);
  Uni2AnsiBuff(str2, lpszShortPath, cchBuffer);
  FreeUni(str1);

  return ret;
}

static UINT WINAPI HookGetTempFileNameA(LPCSTR lpPathName,
  LPCSTR lpPrefixString, UINT uUnique, LPSTR lpTempFileName)
{
  UINT ret;
  LPWSTR str1;
  LPWSTR str2;
  WCHAR str3[MAX_PATH];

  oh_db_log((OL_DBG, OD_FILESYS, "GetTempFileNameA"));

  str1 = Ansi2Uni(lpPathName);
  str2 = Ansi2Uni(lpPrefixString);
  ret = GetTempFileNameW(str1, str2, uUnique, str3);
  Uni2AnsiBuff(str3, lpTempFileName, MAX_PATH);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookGetTempPathA(DWORD nBufferLength, LPSTR lpBuffer)
{
  DWORD ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "GetTempPathA"));

  str1 = _alloca(nBufferLength << 1);
  ret = GetTempPathW(nBufferLength, str1);
  Uni2AnsiBuff(str1, lpBuffer, nBufferLength);

  return ret;
}

static BOOL WINAPI HookMoveFileA(LPCSTR lpExistingFileName,
  LPCSTR lpNewFileName)
{
  BOOL ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "MoveFileA"));

  str1 = Ansi2Uni(lpExistingFileName);
  str2 = Ansi2Uni(lpNewFileName);
  ret = MoveFileW(str1, str2);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookQueryDosDeviceA(LPCSTR lpDeviceName,
  LPSTR lpTargetPath, DWORD ucchMax)
{
  DWORD ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "QueryDosDeviceA"));

  str1 = Ansi2Uni(lpDeviceName);
  str2 = _alloca(ucchMax << 1);
  ret = QueryDosDeviceW(str1, str2, ucchMax);
  Uni2AnsiBuff(str2, lpTargetPath, ucchMax);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookRemoveDirectoryA(LPCSTR lpPathName)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "RemoveDirectoryA"));

  str1 = Ansi2Uni(lpPathName);
  ret = RemoveDirectoryW(str1);
  FreeUni(str1);

  return ret;
}

static DWORD WINAPI HookSearchPathA(LPCSTR lpPath, LPCSTR lpFileName,
  LPCSTR lpExtension, DWORD nBufferLength, LPSTR lpBuffer,
  LPSTR *lpFilePart)
{
  DWORD ret;
  LPWSTR str1;
  LPWSTR str2;
  LPWSTR str3;
  LPWSTR str4;
  LPWSTR str5;
  int len, i;

  oh_db_log((OL_DBG, OD_FILESYS, "SearchPathA"));

  str1 = Ansi2Uni(lpPath);
  str2 = Ansi2Uni(lpFileName);
  str3 = Ansi2Uni(lpExtension);
  str4 = _alloca(nBufferLength << 1);
  ret = SearchPathW(str1, str2, str3, nBufferLength, str4, &str5);
  Uni2AnsiBuff(str4, lpBuffer, nBufferLength);
  len = lstrlenA(lpBuffer);
  for (i = len - 1; i >= 0; i--)
  {
    if (lpBuffer[i] == '\\')
    {
      *lpFilePart = &lpBuffer[i + 1];
      break;
    }
  }
  if (i < 0)
    *lpFilePart = NULL;
  FreeUni(str3);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookSetCurrentDirectoryA(LPCSTR lpPathName)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "SetCurrentDirectoryA"));

  str1 = Ansi2Uni(lpPathName);
  ret = SetCurrentDirectoryW(str1);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookSetFileAttributesA(LPCSTR lpFileName,
  DWORD dwFileAttributes)
{
  BOOL ret;
  LPWSTR str1;

  oh_db_log((OL_DBG, OD_FILESYS, "SetFileAttributesA"));

  str1 = Ansi2Uni(lpFileName);
  ret = SetFileAttributesW(str1, dwFileAttributes);
  FreeUni(str1);

  return ret;
}

static BOOL WINAPI HookSetVolumeLabelA(LPCSTR lpRootPathName,
  LPCSTR lpVolumeName)
{
  BOOL ret;
  LPWSTR str1;
  LPWSTR str2;

  oh_db_log((OL_DBG, OD_FILESYS, "SetVolumeLabelA"));

  str1 = Ansi2Uni(lpRootPathName);
  str2 = Ansi2Uni(lpVolumeName);
  ret = SetVolumeLabelW(str1, str2);
  FreeUni(str2);
  FreeUni(str1);

  return ret;
}

static LPSTR WINAPI HookCharLowerA(LPSTR lpsz)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharLowerA"));

  ret = CharLowerA(lpsz);

  return ret;
}

static LPWSTR WINAPI HookCharLowerW(LPWSTR lpsz)
{
  LPWSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharLowerW"));

  ret = CharLowerW(lpsz);

  return ret;
}

static DWORD WINAPI HookCharLowerBuffA(LPSTR lpsz, DWORD cchLength)
{
  DWORD ret;

  oh_db_log((OL_DBG, OD_DEF, "CharLowerBuffA"));

  ret = CharLowerBuffA(lpsz, cchLength);

  return ret;
}

static DWORD WINAPI HookCharLowerBuffW(LPWSTR lpsz, DWORD cchLength)
{
  DWORD ret;

  oh_db_log((OL_DBG, OD_DEF, "CharLowerBuffW"));

  ret = CharLowerBuffW(lpsz, cchLength);

  return ret;
}

static LPSTR WINAPI HookCharNextA(LPCSTR lpsz)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharNextA"));

  ret = CharNextA(lpsz);

  return ret;
}

static LPWSTR WINAPI HookCharNextW(LPCWSTR lpsz)
{
  LPWSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharNextW"));

  ret = CharNextW(lpsz);

  return ret;
}

static LPSTR WINAPI HookCharNextExA(WORD CodePage, LPCSTR lpCurrentChar,
  DWORD dwFlags)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharNextExA"));

  ret = CharNextExA(CodePage, lpCurrentChar, dwFlags);

  return ret;
}

static LPSTR WINAPI HookCharPrevA(LPCSTR lpszStart, LPCSTR lpszCurrent)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharPrevA"));

  ret = CharPrevA(lpszStart, lpszCurrent);

  return ret;
}

static LPWSTR WINAPI HookCharPrevW(LPCWSTR lpszStart, LPCWSTR lpszCurrent)
{
  LPWSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharPrevW"));

  ret = CharPrevW(lpszStart, lpszCurrent);

  return ret;
}

static LPSTR WINAPI HookCharPrevExA(WORD CodePage, LPCSTR lpStart,
  LPCSTR lpCurrentChar, DWORD dwFlags)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharPrevExA"));

  ret = CharPrevExA(CodePage, lpStart, lpCurrentChar, dwFlags);

  return ret;
}

static BOOL WINAPI HookCharToOemA(LPCSTR lpszSrc, LPSTR lpszDst)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "CharToOemA"));

  ret = CharToOemA(lpszSrc, lpszDst);

  return ret;
}

static BOOL WINAPI HookCharToOemW(LPCWSTR lpszSrc, LPSTR lpszDst)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "CharToOemW"));

  ret = CharToOemW(lpszSrc, lpszDst);

  return ret;
}

static BOOL WINAPI HookCharToOemBuffA(LPCSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "CharToOemBuffA"));

  ret = CharToOemBuffA(lpszSrc, lpszDst, cchDstLength);

  return ret;
}

static BOOL WINAPI HookCharToOemBuffW(LPCWSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "CharToOemBuffW"));

  ret = CharToOemBuffW(lpszSrc, lpszDst, cchDstLength);

  return ret;
}

static LPSTR WINAPI HookCharUpperA(LPSTR lpsz)
{
  LPSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharUpperA"));

  ret = CharUpperA(lpsz);

  return ret;
}

static LPWSTR WINAPI HookCharUpperW(LPWSTR lpsz)
{
  LPWSTR ret;

  oh_db_log((OL_DBG, OD_DEF, "CharUpperW"));

  ret = CharUpperW(lpsz);

  return ret;
}

static DWORD WINAPI HookCharUpperBuffA(LPSTR lpsz, DWORD cchLength)
{
  DWORD ret;

  oh_db_log((OL_DBG, OD_DEF, "CharUpperBuffA"));

  ret = CharUpperBuffA(lpsz, cchLength);

  return ret;
}

static DWORD WINAPI HookCharUpperBuffW(LPWSTR lpsz, DWORD cchLength)
{
  DWORD ret;

  oh_db_log((OL_DBG, OD_DEF, "CharUpperBuffW"));

  ret = CharUpperBuffW(lpsz, cchLength);

  return ret;
}

static int WINAPI HookCompareStringA(LCID Locale, DWORD dwCmpFlags,
  LPCSTR lpString1, int cchCount1, LPCSTR lpString2, int cchCount2)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "CompareStringA"));

  ret =
    CompareStringA(Locale, dwCmpFlags, lpString1, cchCount1, lpString2,
      cchCount2);

  return ret;
}

static int WINAPI HookCompareStringW(LCID Locale, DWORD dwCmpFlags,
  LPCWSTR lpString1, int cchCount1, LPCWSTR lpString2, int cchCount2)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "CompareStringW"));

  ret =
    CompareStringW(Locale, dwCmpFlags, lpString1, cchCount1, lpString2,
      cchCount2);

  return ret;
}

static int WINAPI HookFoldStringA(DWORD dwMapFlags, LPCSTR lpSrcStr,
  int cchSrc, LPSTR lpDestStr, int cchDest)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "FoldStringA"));

  ret = FoldStringA(dwMapFlags, lpSrcStr, cchSrc, lpDestStr, cchDest);

  return ret;
}

static int WINAPI HookFoldStringW(DWORD dwMapFlags, LPCWSTR lpSrcStr,
  int cchSrc, LPWSTR lpDestStr, int cchDest)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "FoldStringW"));

  ret = FoldStringW(dwMapFlags, lpSrcStr, cchSrc, lpDestStr, cchDest);

  return ret;
}

static BOOL WINAPI HookGetStringTypeA(LCID Locale, DWORD dwInfoType,
  LPCSTR lpSrcStr, int cchSrc, LPWORD lpCharType)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetStringTypeA"));

  ret = GetStringTypeA(Locale, dwInfoType, lpSrcStr, cchSrc, lpCharType);

  return ret;
}

static BOOL WINAPI HookGetStringTypeW(LCID Locale, LPCWSTR lpSrcStr,
  int cchSrc, LPWORD lpCharType)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetStringTypeW"));

  ret = GetStringTypeW(Locale, lpSrcStr, cchSrc, lpCharType);

  return ret;
}

static BOOL WINAPI HookGetStringTypeExA(LCID Locale, DWORD dwInfoType,
  LPCSTR lpSrcStr, int cchSrc, LPWORD lpCharType)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetStringTypeExA"));

  ret = GetStringTypeExA(Locale, dwInfoType, lpSrcStr, cchSrc, lpCharType);

  return ret;
}

static BOOL WINAPI HookGetStringTypeExW(LCID Locale, DWORD dwInfoType,
  LPCWSTR lpSrcStr, int cchSrc, LPWORD lpCharType)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetStringTypeExW"));

  ret = GetStringTypeExW(Locale, dwInfoType, lpSrcStr, cchSrc, lpCharType);

  return ret;
}

static BOOL WINAPI HookIsCharAlphaA(CHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharAlphaA"));

  ret = IsCharAlphaA(ch);

  return ret;
}

static BOOL WINAPI HookIsCharAlphaW(WCHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharAlphaW"));

  ret = IsCharAlphaW(ch);

  return ret;
}

static BOOL WINAPI HookIsCharAlphaNumericA(CHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharAlphaNumericA"));

  ret = IsCharAlphaNumericA(ch);

  return ret;
}

static BOOL WINAPI HookIsCharAlphaNumericW(WCHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharAlphaNumericW"));

  ret = IsCharAlphaNumericW(ch);

  return ret;
}

static BOOL WINAPI HookIsCharLowerA(CHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharLowerA"));

  ret = IsCharLowerA(ch);

  return ret;
}

static BOOL WINAPI HookIsCharLowerW(WCHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharLowerW"));

  ret = IsCharLowerW(ch);

  return ret;
}

static BOOL WINAPI HookIsCharUpperA(CHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharUpperA"));

  ret = IsCharUpperA(ch);

  return ret;
}

static BOOL WINAPI HookIsCharUpperW(WCHAR ch)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsCharUpperW"));

  ret = IsCharUpperW(ch);

  return ret;
}

static int WINAPI HookLoadStringA(HINSTANCE hInstance, UINT uID,
  LPSTR lpBuffer, int nBufferMax)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "LoadStringA"));

  ret = LoadStringA(hInstance, uID, lpBuffer, nBufferMax);

  return ret;
}

static int WINAPI HookLoadStringW(HINSTANCE hInstance, UINT uID,
  LPWSTR lpBuffer, int nBufferMax)
{
  int ret;
/*  OTHWSTR inStr;
  OTHWSTR outStr; */

  oh_db_log((OL_DBG, OD_DEF, "LoadStringW"));

  ret = LoadStringW(hInstance, uID, lpBuffer, nBufferMax);

/*  inStr.lpStr = (LPWSTR)lpBuffer;
  inStr.iLen = ret;
  OthBeginHookTextW(NULL, &inStr, &outStr);
  OthEndHookTextW(NULL, &inStr, &outStr); */

  return ret;
}

static BOOL WINAPI HookOemToCharA(LPCSTR lpszSrc, LPSTR lpszDst)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "OemToCharA"));

  ret = OemToCharA(lpszSrc, lpszDst);

  return ret;
}

static BOOL WINAPI HookOemToCharW(LPCSTR lpszSrc, LPWSTR lpszDst)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "OemToCharW"));

  ret = OemToCharW(lpszSrc, lpszDst);

  return ret;
}

static BOOL WINAPI HookOemToCharBuffA(LPCSTR lpszSrc, LPSTR lpszDst,
  DWORD cchDstLength)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "OemToCharBuffA"));

  ret = OemToCharBuffA(lpszSrc, lpszDst, cchDstLength);

  return ret;
}

static BOOL WINAPI HookOemToCharBuffW(LPCSTR lpszSrc, LPWSTR lpszDst,
  DWORD cchDstLength)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "OemToCharBuffW"));

  ret = OemToCharBuffW(lpszSrc, lpszDst, cchDstLength);

  return ret;
}

static HFONT WINAPI HookCreateFontA(int nHeight, int nWidth, int nEscapement,
  int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline,
  DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision,
  DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily,
  LPCSTR lpszFace)
{
  HFONT ret;
  LPCSTR lpszNewFace;

  oh_db_log((OL_DBG, OD_DEF, "CreateFontA"));

  OthHookCharSet((UINT *)&fdwCharSet);

  lpszNewFace = JP2ENGFontName(lpszFace);
  if (!lpszNewFace)
    lpszNewFace = lpszFace;

  ret =
    CreateFontA(nHeight, nWidth, nEscapement, nOrientation, fnWeight,
      fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision,
      fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszNewFace);

  return ret;
}

static int WINAPI HookEnumFontsA(HDC hdc, LPCSTR lpFaceName,
  FONTENUMPROCA lpFontFunc, LPARAM lParam)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontsA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = EnumFontsA(hdc, lpFaceName, lpFontFunc, lParam);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookEnumFontsW(HDC hdc, LPCWSTR lpFaceName,
  FONTENUMPROCW lpFontFunc, LPARAM lParam)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontsW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = EnumFontsW(hdc, lpFaceName, lpFontFunc, lParam);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static FONTENUMPROCA lpOrgEnumFontFamProc;

static int CALLBACK HookEnumFontFamProc(CONST LOGFONTA *lpelf,
  CONST TEXTMETRICA *lpntm, DWORD FontType, LPARAM lParam)
{
  LOGFONTA font;
  int ret;
  LPSTR lpNewFontFaceName;
  UINT charset;

  ret = lpOrgEnumFontFamProc(lpelf, lpntm, FontType, lParam);
  if (ret == 0)
    return 0;

  font = *lpelf;

  lpNewFontFaceName = ENG2JPFontName(font.lfFaceName);
  if (lpNewFontFaceName == NULL)
    return ret;

  lstrcpyA(font.lfFaceName, lpNewFontFaceName);

  charset = font.lfCharSet;
  OthHookCharSet(&charset);
  font.lfCharSet = charset;

  ret = lpOrgEnumFontFamProc(&font, lpntm, FontType, lParam);

  return ret;
}

static int WINAPI HookEnumFontFamiliesA(HDC hdc, LPCSTR lpszFamily,
  FONTENUMPROCA lpEnumFontFamProc, LPARAM lParam)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontFamiliesA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  lpOrgEnumFontFamProc = lpEnumFontFamProc;
  ret = EnumFontFamiliesA(hdc, lpszFamily, HookEnumFontFamProc, lParam);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookEnumFontFamiliesW(HDC hdc, LPCWSTR lpszFamily,
  FONTENUMPROCW lpEnumFontFamProc, LPARAM lParam)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontFamiliesW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = EnumFontFamiliesW(hdc, lpszFamily, lpEnumFontFamProc, lParam);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookLCMapStringA(LCID Locale, DWORD dwMapFlags,
  LPCSTR lpSrcStr, int cchSrc, LPSTR lpDestStr, int cchDest)
{
/*  oh_db_log((OL_DBG, OD_DEF, "LCMapStringA")); */

  return
    LCMapStringA(Locale, dwMapFlags, lpSrcStr, cchSrc, lpDestStr, cchDest);
}

static int WINAPI HookLCMapStringW(LCID Locale, DWORD dwMapFlags,
  LPCWSTR lpSrcStr, int cchSrc, LPWSTR lpDestStr, int cchDest)
{
/*  oh_db_log((OL_DBG, OD_DEF, "LCMapStringW")); */

  return
    LCMapStringW(Locale, dwMapFlags, lpSrcStr, cchSrc, lpDestStr, cchDest);
}

static BOOL WINAPI HookGetCPInfoExA(UINT CodePage, DWORD dwFlags,
  LPCPINFOEXA lpCPInfoEx)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetCPInfoExA"));

  OthHookCodePage(&CodePage);

  ret = GetCPInfoExA(CodePage, dwFlags, lpCPInfoEx);

  return ret;
}

static BOOL WINAPI HookGetCPInfoExW(UINT CodePage, DWORD dwFlags,
  LPCPINFOEXW lpCPInfoEx)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetCPInfoExW"));

  OthHookCodePage(&CodePage);

  ret = GetCPInfoExW(CodePage, dwFlags, lpCPInfoEx);

  return ret;
}

static BOOL WINAPI HookGetCPInfo(UINT CodePage, LPCPINFO lpCPInfo)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "GetCPInfo"));

  OthHookCodePage(&CodePage);

  ret = GetCPInfo(CodePage, lpCPInfo);

  return ret;
}

static UINT WINAPI HookGetOEMCP(void)
{
  UINT CodePage;

  oh_db_log((OL_DBG, OD_DEF, "GetOEMCP"));

  CodePage = GetOEMCP();

  OthHookCodePage(&CodePage);

  return CodePage;
}

static UINT WINAPI HookGetACP(void)
{
  UINT CodePage;

  oh_db_log((OL_DBG, OD_DEF, "GetACP"));

  CodePage = GetACP();

  OthHookCodePage(&CodePage);

  return CodePage;
}

static BOOL WINAPI HookGetCharWidthA(HDC hdc, UINT iFirstChar, UINT iLastChar,
  LPINT lpBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidthA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidthA(hdc, iFirstChar, iLastChar, lpBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharWidthW(HDC hdc, UINT iFirstChar, UINT iLastChar,
  LPINT lpBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidthW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidthW(hdc, iFirstChar, iLastChar, lpBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentPointA(HDC hdc, LPCSTR lpString,
  int cbString, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentPointA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextExtentPointA(hdc, lpString, cbString, lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentPointW(HDC hdc, LPCWSTR lpString,
  int cbString, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentPointW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextExtentPointW(hdc, lpString, cbString, lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookWideCharToMultiByte(UINT CodePage, DWORD dwFlags,
  LPCWSTR lpWideCharStr, int cchWideChar, LPSTR lpMultiByteStr,
  int cbMultiByte, LPCSTR lpDefaultChar, LPBOOL lpUsedDefaultChar)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "WideCharToMultiByte"));

  ret =
    OthHookWideCharToMultiByte(CodePage, dwFlags, lpWideCharStr, cchWideChar,
      lpMultiByteStr, cbMultiByte, lpDefaultChar, lpUsedDefaultChar);

  return ret;
}

static int WINAPI HookMultiByteToWideChar(UINT CodePage, DWORD dwFlags,
  LPCSTR lpMultiByteStr, int cbMultiByte, LPWSTR lpWideCharStr,
  int cchWideChar)
{
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "MultiByteToWideChar"));

  ret =
    OthHookMultiByteToWideChar(CodePage, dwFlags, lpMultiByteStr,
      cbMultiByte, lpWideCharStr, cchWideChar);

  return ret;
}

static int WINAPI HookGetTextCharsetInfo(HDC hdc, LPFONTSIGNATURE lpSig,
  DWORD dwFlags)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextCharsetInfo"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextCharsetInfo(hdc, lpSig, dwFlags);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookGetTextCharset(HDC hdc)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextCharset"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextCharset(hdc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookIsDBCSLeadByteEx(UINT CodePage, BYTE TestChar)
{
  BOOL ret;

  oh_db_log((OL_DBG, OD_DEF, "IsDBCSLeadByteEx"));

  OthHookCodePage(&CodePage);

  ret = IsDBCSLeadByteEx(CodePage, TestChar);

  return ret;
}

static int WINAPI HookEnumFontFamiliesExA(HDC hdc, LPLOGFONTA lpLogfont,
  FONTENUMPROCA lpEnumFontFamExProc, LPARAM lParam, DWORD dwFlags)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontFamiliesExA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    EnumFontFamiliesExA(hdc, lpLogfont, lpEnumFontFamExProc, lParam, dwFlags);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookEnumFontFamiliesExW(HDC hdc, LPLOGFONTW lpLogfont,
  FONTENUMPROCW lpEnumFontFamExProc, LPARAM lParam, DWORD dwFlags)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "EnumFontFamiliesExW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    EnumFontFamiliesExW(hdc, lpLogfont, lpEnumFontFamExProc, lParam, dwFlags);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharABCWidthsA(HDC hdc, UINT uFirstChar,
  UINT uLastChar, LPABC lpabc)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharABCWidthsA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharABCWidthsA(hdc, uFirstChar, uLastChar, lpabc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharABCWidthsW(HDC hdc, UINT uFirstChar,
  UINT uLastChar, LPABC lpabc)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharABCWidthsW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharABCWidthsW(hdc, uFirstChar, uLastChar, lpabc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharABCWidthsFloatA(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPABCFLOAT lpABCF)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharABCWidthsFloatA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharABCWidthsFloatA(hdc, iFirstChar, iLastChar, lpABCF);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharABCWidthsFloatW(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPABCFLOAT lpABCF)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharABCWidthsFloatW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharABCWidthsFloatW(hdc, iFirstChar, iLastChar, lpABCF);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetCharacterPlacementA(HDC hdc, LPCSTR lpString,
  int nCount, int nMaxExtent, LPGCP_RESULTSA lpResults, DWORD dwFlags)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharacterPlacementA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetCharacterPlacementA(hdc, lpString, nCount, nMaxExtent, lpResults,
      dwFlags);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetCharacterPlacementW(HDC hdc, LPCWSTR lpString,
  int nCount, int nMaxExtent, LPGCP_RESULTSW lpResults, DWORD dwFlags)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharacterPlacementW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetCharacterPlacementW(hdc, lpString, nCount, nMaxExtent, lpResults,
      dwFlags);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharWidth32A(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPINT lpBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidth32A"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidth32A(hdc, iFirstChar, iLastChar, lpBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharWidth32W(HDC hdc, UINT iFirstChar,
  UINT iLastChar, LPINT lpBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidth32W"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidth32W(hdc, iFirstChar, iLastChar, lpBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharWidthFloatA(HDC hdc, UINT iFirstChar,
  UINT iLastChar, PFLOAT pxBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidthFloatA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidthFloatA(hdc, iFirstChar, iLastChar, pxBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetCharWidthFloatW(HDC hdc, UINT iFirstChar,
  UINT iLastChar, PFLOAT pxBuffer)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetCharWidthFloatW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetCharWidthFloatW(hdc, iFirstChar, iLastChar, pxBuffer);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetFontData(HDC hdc, DWORD dwTable, DWORD dwOffset,
  LPVOID lpvBuffer, DWORD cbData)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetFontData"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetFontData(hdc, dwTable, dwOffset, lpvBuffer, cbData);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetFontLanguageInfo(HDC hdc)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetFontLanguageInfo"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetFontLanguageInfo(hdc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetGlyphOutlineA(HDC hdc, UINT uChar, UINT uFormat,
  LPGLYPHMETRICS lpgm, DWORD cbBuffer, LPVOID lpvBuffer, CONST MAT2 *lpmat2)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;
  CHAR szChar[5];
  int i, j;

  oh_db_log((OL_DBG, OD_DEF, "GetGlyphOutlineA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  szChar[0] = (uChar >> 24) & 0xff;
  szChar[1] = (uChar >> 16) & 0xff;
  szChar[2] = (uChar >> 8) & 0xff;
  szChar[3] = (uChar) & 0xff;
  szChar[4] = 0;

  for (i = 0, j = 0; i < 5; i++)
  {
    if (szChar[i] != 0)
    {
      szChar[j] = szChar[i];
      ++j;
    }
  }
  szChar[j] = 0;

  inStr.lpStr = szChar;
  inStr.iLen = lstrlenA(inStr.lpStr);

  OthBeginHookTextA(hdc, &inStr, &outStr);

  if (inStr.iLen == 0)
  {
    ret = GetGlyphOutlineW(hdc, 0, uFormat, lpgm, cbBuffer, lpvBuffer, lpmat2);
  }
  else
  {
    ret = GetGlyphOutlineW(hdc, (UINT)outStr.lpStr[0], uFormat, lpgm, cbBuffer,
      lpvBuffer, lpmat2);
  }

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetGlyphOutlineW(HDC hdc, UINT uChar, UINT uFormat,
  LPGLYPHMETRICS lpgm, DWORD cbBuffer, LPVOID lpvBuffer, CONST MAT2 *lpmat2)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "GetGlyphOutlineW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  inStr.lpStr = (LPWSTR)&uChar;
  inStr.iLen = lstrlenW(inStr.lpStr);
  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret =
    GetGlyphOutlineW(hdc, uChar, uFormat, lpgm, cbBuffer, lpvBuffer, lpmat2);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetKerningPairsA(HDC hdc, DWORD nNumPairs,
  LPKERNINGPAIR lpkrnpair)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetKerningPairsA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetKerningPairsA(hdc, nNumPairs, lpkrnpair);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetKerningPairsW(HDC hdc, DWORD nNumPairs,
  LPKERNINGPAIR lpkrnpair)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetKerningPairsW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetKerningPairsW(hdc, nNumPairs, lpkrnpair);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static UINT WINAPI HookGetOutlineTextMetricsA(HDC hdc, UINT cbData,
  LPOUTLINETEXTMETRICA lpOTM)
{
  UINT ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetOutlineTextMetricsA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetOutlineTextMetricsA(hdc, cbData, lpOTM);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static UINT WINAPI HookGetOutlineTextMetricsW(HDC hdc, UINT cbData,
  LPOUTLINETEXTMETRICW lpOTM)
{
  UINT ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetOutlineTextMetricsW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetOutlineTextMetricsW(hdc, cbData, lpOTM);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetTabbedTextExtentA(HDC hdc, LPCSTR lpString,
  int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTabbedTextExtentA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetTabbedTextExtentA(hdc, lpString, nCount, nTabPositions,
      lpnTabStopPositions);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookGetTabbedTextExtentW(HDC hdc, LPCWSTR lpString,
  int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTabbedTextExtentW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetTabbedTextExtentW(hdc, lpString, nCount, nTabPositions,
      lpnTabStopPositions);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static UINT WINAPI HookGetTextAlign(HDC hdc)
{
  UINT ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextAlign"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextAlign(hdc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookGetTextCharacterExtra(HDC hdc)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextCharacterExtra"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextCharacterExtra(hdc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static COLORREF WINAPI HookGetTextColor(HDC hdc)
{
  COLORREF ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextColor"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextColor(hdc);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentExPointA(HDC hdc, LPCSTR lpszStr,
  int cchString, int nMaxExtent, LPINT lpnFit, LPINT alpDx, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentExPointA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetTextExtentExPointA(hdc, lpszStr, cchString, nMaxExtent, lpnFit, alpDx,
      lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentExPointW(HDC hdc, LPCWSTR lpszStr,
  int cchString, int nMaxExtent, LPINT lpnFit, LPINT alpDx, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentExPointW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret =
    GetTextExtentExPointW(hdc, lpszStr, cchString, nMaxExtent, lpnFit, alpDx,
      lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentPoint32A(HDC hdc, LPCSTR lpString,
  int cbString, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentPoint32A"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextExtentPoint32A(hdc, lpString, cbString, lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextExtentPoint32W(HDC hdc, LPCWSTR lpString,
  int cbString, LPSIZE lpSize)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextExtentPoint32W"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextExtentPoint32W(hdc, lpString, cbString, lpSize);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookGetTextFaceA(HDC hdc, int nCount, LPSTR lpFaceName)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextFaceA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextFaceA(hdc, nCount, lpFaceName);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookGetTextFaceW(HDC hdc, int nCount, LPWSTR lpFaceName)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextFaceW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextFaceW(hdc, nCount, lpFaceName);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextMetricsA(HDC hdc, LPTEXTMETRICA lptm)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextMetricsA"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextMetricsA(hdc, lptm);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookGetTextMetricsW(HDC hdc, LPTEXTMETRICW lptm)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "GetTextMetricsW"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = GetTextMetricsW(hdc, lptm);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static DWORD WINAPI HookSetMapperFlags(HDC hdc, DWORD dwFlag)
{
  DWORD ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "SetMapperFlags"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = SetMapperFlags(hdc, dwFlag);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static UINT WINAPI HookSetTextAlign(HDC hdc, UINT fMode)
{
  UINT ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "SetTextAlign"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = SetTextAlign(hdc, fMode);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookSetTextCharacterExtra(HDC hdc, int nCharExtra)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "SetTextCharacterExtra"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = SetTextCharacterExtra(hdc, nCharExtra);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static COLORREF WINAPI HookSetTextColor(HDC hdc, COLORREF crColor)
{
  COLORREF ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "SetTextColor"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = SetTextColor(hdc, crColor);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookSetTextJustification(HDC hdc, int nBreakExtra,
  int nBreakCount)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;

  oh_db_log((OL_DBG, OD_DEF, "SetTextJustification"));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ret = SetTextJustification(hdc, nBreakExtra, nBreakCount);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookTextOutA(HDC hdc, int nXStart, int nYStart,
  LPCSTR lpString, int cbString)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "TextOutA(%p, %d, %d, XXX, %d)", hdc, nXStart,
    nYStart, cbString ));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (cbString < 0)
  {
    cbString = lstrlenA(lpString);
  }

  inStr.lpStr = (LPSTR)lpString;
  inStr.iLen = cbString;

  OthBeginHookTextA(hdc, &inStr, &outStr);

  ret = TextOutW(hdc, nXStart, nYStart, outStr.lpStr, outStr.iLen);

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookTextOutW(HDC hdc, int nXStart, int nYStart,
  LPCWSTR lpString, int cbString)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "TextOutW(%p, %d, %d, XXX, %d)", hdc, nXStart,
    nYStart, cbString ));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (cbString < 0)
  {
    cbString = lstrlenW(lpString);
  }

  inStr.lpStr = (LPWSTR)lpString;
  inStr.iLen = cbString;

  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret = TextOutW(hdc, nXStart, nYStart, outStr.lpStr, outStr.iLen);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookExtTextOutA(HDC hdc, int X, int Y, UINT fuOptions,
  CONST RECT *lprc, LPCSTR lpString, UINT cbCount, CONST INT *lpDx)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "ExtTextOutA(%p, %d, %d, %08x, XXX, XXX, %d, XXX)"
    ,hdc, X, Y, fuOptions, cbCount));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

/*  {
    inStr.lpStr = "ExtTextOutA:";
    inStr.iLen = lstrlenA(inStr.lpStr);
    OthBeginHookTextA(hdc, &inStr, &outStr);
    OthEndHookTextA(hdc, &inStr, &outStr);
  }*/

  inStr.lpStr = (LPSTR)lpString;
  inStr.iLen = cbCount;

  OthBeginHookTextA(hdc, &inStr, &outStr);

  /* ExtTextOutW and ExtTextOutA are different */
  ret = ExtTextOutA(hdc, X, Y, fuOptions, lprc, lpString, cbCount, lpDx);

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookExtTextOutW(HDC hdc, int X, int Y, UINT fuOptions,
  CONST RECT *lprc, LPCWSTR lpString, UINT cbCount, CONST INT *lpDx)
{
  BOOL ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF,
    "ExtTextOutW(%p, %d, %d, %08x, XXX, XXX, %d, XXX)",hdc, X, Y, fuOptions,
    cbCount));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  inStr.lpStr = (LPWSTR)lpString;
  inStr.iLen = cbCount;

  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret =
    ExtTextOutW(hdc, X, Y, fuOptions, lprc, outStr.lpStr, outStr.iLen, lpDx);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}
/*
static BOOL WINAPI HookPolyTextOutA(HDC hdc, CONST POLYTEXTA *pptxt,
  int cStrings)
{
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  POLYTEXTW *ppNewPolyText;
  int i;
  BOOL ret;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "PolyTextOutA(%p, XXX, %d)", hdc, cStrings));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ppNewPolyText = _alloca(sizeof(POLYTEXTW) * cStrings);
  OH_ASSERT(ppNewPolyText != NULL);

  for (i = 0; i < cStrings; i++)
  {
    ppNewPolyText[i].x = pptxt[i].x;
    ppNewPolyText[i].y = pptxt[i].y;
    ppNewPolyText[i].uiFlags = pptxt[i].uiFlags;
    ppNewPolyText[i].rcl = pptxt[i].rcl;
    ppNewPolyText[i].pdx = pptxt[i].pdx;
    inStr.lpStr = (LPSTR)pptxt[i].lpstr;
    inStr.iLen = pptxt[i].n;

    OthBeginHookTextA(hdc, &inStr, &outStr);

    ppNewPolyText[i].lpstr = outStr.lpStr;
    ppNewPolyText[i].n = outStr.iLen;
  }

  ret = PolyTextOutW(hdc, ppNewPolyText, cStrings);

  for (i = 0; i < cStrings; i++)
  {
    inStr.lpStr = (LPSTR)pptxt[i].lpstr;
    inStr.iLen = pptxt[i].n;
    outStr.lpStr = (LPWSTR)ppNewPolyText[i].lpstr;
    outStr.iLen = ppNewPolyText[i].n;

    OthEndHookTextA(hdc, &inStr, &outStr);
  }

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static BOOL WINAPI HookPolyTextOutW(HDC hdc, CONST POLYTEXTW *pptxt,
  int cStrings)
{
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  POLYTEXTW *ppNewPolyText;
  int i;
  BOOL ret;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "PolyTextOutW(%p, XXX, %d)", hdc, cStrings));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  ppNewPolyText = _alloca(sizeof(POLYTEXTW) * cStrings);
  OH_ASSERT(ppNewPolyText != NULL);

  for (i = 0; i < cStrings; i++)
  {
    ppNewPolyText[i] = pptxt[i];
    inStr.lpStr = (LPWSTR)pptxt[i].lpstr;
    inStr.iLen = pptxt[i].n;

    OthBeginHookTextW(hdc, &inStr, &outStr);

    ppNewPolyText[i].lpstr = outStr.lpStr;
    ppNewPolyText[i].n = outStr.iLen;

  }

  ret = PolyTextOutW(hdc, ppNewPolyText, cStrings);

  for (i = 0; i < cStrings; i++)
  {
    inStr.lpStr = (LPWSTR)pptxt[i].lpstr;
    inStr.iLen = pptxt[i].n;
    outStr.lpStr = (LPWSTR)ppNewPolyText[i].lpstr;
    outStr.iLen = ppNewPolyText[i].n;

    OthEndHookTextW(hdc, &inStr, &outStr);
  }

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}
*/
static LONG WINAPI HookTabbedTextOutA(HDC hdc, int X, int Y,
  LPCSTR lpString, int nCount, int nTabPositions,
  CONST LPINT lpnTabStopPositions, int nTabOrigin)
{
  LONG ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF,
    "TabbedTextOutA(%p, %d, %d, XXX, %d, %d, XXX, %d)", X, Y, nCount,
    nTabPositions, nTabOrigin));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (nCount < 0)
  {
    nCount = lstrlenA(lpString);
  }

  inStr.lpStr = (LPSTR)lpString;
  inStr.iLen = nCount;

  OthBeginHookTextA(hdc, &inStr, &outStr);

  ret =
    TabbedTextOutW(hdc, X, Y, outStr.lpStr, outStr.iLen, nTabPositions,
      lpnTabStopPositions, nTabOrigin);

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static LONG WINAPI HookTabbedTextOutW(HDC hdc, int X, int Y,
  LPCWSTR lpString, int nCount, int nTabPositions,
  CONST LPINT lpnTabStopPositions, int nTabOrigin)
{
  LONG ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF,
    "TabbedTextOutW(%p, %d, %d, XXX, %d, %d, XXX, %d)", X, Y, nCount,
    nTabPositions, nTabOrigin));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (nCount < 0)
  {
    nCount = lstrlenW(lpString);
  }

  inStr.lpStr = (LPWSTR)lpString;
  inStr.iLen = nCount;

  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret =
    TabbedTextOutW(hdc, X, Y, outStr.lpStr, outStr.iLen, nTabPositions,
      lpnTabStopPositions, nTabOrigin);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookDrawTextA(HDC hdc, LPCSTR lpString, int nCount,
  LPRECT lpRect, UINT uFormat)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "DrawTextA(%p, XXX, %d, XXX, %08x)", hdc, nCount,
    uFormat));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (nCount < 0)
  {
    nCount = lstrlenA(lpString);
  }

  inStr.lpStr = (LPSTR)lpString;
  inStr.iLen = nCount;

  OthBeginHookTextA(hdc, &inStr, &outStr);

  ret = DrawTextW(hdc, outStr.lpStr, outStr.iLen, lpRect, uFormat);

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookDrawTextW(HDC hdc, LPCWSTR lpString, int nCount,
  LPRECT lpRect, UINT uFormat)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "DrawTextW(%p, XXX, %d, XXX, %08x)", hdc, nCount,
    uFormat));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (nCount < 0)
  {
    nCount = lstrlenW(lpString);
  }

  inStr.lpStr = (LPWSTR)lpString;
  inStr.iLen = nCount;

  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret = DrawTextW(hdc, outStr.lpStr, outStr.iLen, lpRect, uFormat);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookDrawTextExA(HDC hdc, LPSTR lpchText, int cchText,
  LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "DrawTextExA(%p, XXX, %d, XXX, %08x, XXX)", hdc,
    cchText, dwDTFormat));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (cchText < 0)
  {
    cchText = lstrlenA(lpchText);
  }

  if (dwDTFormat & DT_MODIFYSTRING)
  {
    oh_db_log((OL_WRN, OD_DEF,
      "DrawTextExA dwDTFormat contains DT_MODIFYSTRING flag"));
    dwDTFormat = dwDTFormat & (~DT_MODIFYSTRING);
  }

  inStr.lpStr = (LPSTR)lpchText;
  inStr.iLen = cchText;

  OthBeginHookTextA(hdc, &inStr, &outStr);

  ret =
    DrawTextExW(hdc, outStr.lpStr, outStr.iLen, lprc, dwDTFormat, lpDTParams);

  OthEndHookTextA(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static int WINAPI HookDrawTextExW(HDC hdc, LPWSTR lpchText, int cchText,
  LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams)
{
  int ret;
  HGDIOBJ hFontOrg;
  HGDIOBJ hFontNew;
  OTHWSTR inStr;
  OTHWSTR outStr;

  oh_db_log((OL_DBG, OD_DEF, "DrawTextExW(%p, XXX, %d, XXX, %08x, XXX)", hdc,
    cchText, dwDTFormat));

  hFontOrg = GetCurrentObject(hdc, OBJ_FONT);

  hFontNew = OthHookDC(hdc);

  if (cchText < 0)
  {
    cchText = lstrlenW(lpchText);
  }

  if (dwDTFormat & DT_MODIFYSTRING)
  {
    oh_db_log((OL_WRN, OD_DEF,
      "DrawTextExW dwDTFormat contains DT_MODIFYSTRING flag"));
    dwDTFormat = dwDTFormat & (~DT_MODIFYSTRING);
  }

  inStr.lpStr = (LPWSTR)lpchText;
  inStr.iLen = cchText;

  OthBeginHookTextW(hdc, &inStr, &outStr);

  ret =
    DrawTextExW(hdc, outStr.lpStr, outStr.iLen, lprc, dwDTFormat, lpDTParams);

  OthEndHookTextW(hdc, &inStr, &outStr);

  SelectObject(hdc, hFontOrg);
  if (hFontNew)
    DeleteObject(hFontNew);

  return ret;
}

static HMODULE WINAPI HookLoadLibraryA(LPCSTR lpFileName)
{
  HMODULE hmod;
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "LoadLibraryA %s", lpFileName));
  hmod = LoadLibraryA(lpFileName);

  ret = HookInNewModule(hmod, 0);
  OH_ASSERT(ret == 0);

  return hmod;
}

static HMODULE WINAPI HookLoadLibraryW(LPCWSTR lpFileName)
{
  HMODULE hmod;
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "LoadLibraryW %s", lpFileName));
  hmod = LoadLibraryW(lpFileName);

  ret = HookInNewModule(hmod, 0);
  OH_ASSERT(ret == 0);

  return hmod;
}

static HMODULE WINAPI HookLoadLibraryExA(LPCSTR lpFileName, HANDLE hFile,
  DWORD dwFlags)
{
  HMODULE hmod;
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "LoadLibraryExA %s", lpFileName));
  hmod = LoadLibraryExA(lpFileName, hFile, dwFlags);

  ret = HookInNewModule(hmod, dwFlags);
  OH_ASSERT(ret == 0);

  return hmod;
}

static HMODULE WINAPI HookLoadLibraryExW(LPCWSTR lpFileName, HANDLE hFile,
  DWORD dwFlags)
{
  HMODULE hmod;
  int ret;

  oh_db_log((OL_DBG, OD_DEF, "LoadLibraryExW %s", lpFileName));
  hmod = LoadLibraryExW(lpFileName, hFile, dwFlags);

  ret = HookInNewModule(hmod, dwFlags);
  OH_ASSERT(ret == 0);

  return hmod;
}

static FARPROC WINAPI HookGetProcAddress(HMODULE hModule,
  LPCSTR lpProcName)
{
  int i;
  HOOKITEM *hitem;
  FARPROC pfn;

  pfn = GetProcAddress(hModule, lpProcName);

  if (pfn != NULL)
  {
    for (i = 0, hitem = HookList; i < HookListLen; i++, hitem++)
    {
      if ((LPVOID)pfn == hitem->pfnOrgFunc)
      {
        pfn = (FARPROC)hitem->pfnNewFunc;
      }
    }
  }

  return pfn;
}

static int HookInNewModule(HMODULE hmod, DWORD dwFlags)
{
  int i;
  int ret;
  HOOKITEM *hitem;

  if ((hmod != NULL) && (dwFlags & LOAD_LIBRARY_AS_DATAFILE) == 0)
  {
    for (i = 0, hitem = HookList; i < HookListLen; i++, hitem++)
    {
      ret =
        OthHookInOneMod(hitem->lpDllName, hitem->pfnOrgFunc, hitem->pfnNewFunc,
          hmod);
      OH_ASSERT(ret == 0);
    }
  }

  return 0;
}

static LPSTR Uni2Ansi(LPCWSTR str)
{
  UINT codepage = CP_OEMCP;
  int len;
  LPSTR ret;

  OthHookCodePage(&codepage);

  len = WideCharToMultiByte(codepage, 0, str, -1, 0, 0, 0, 0);
  ret = (LPSTR)malloc(len);
  OH_ASSERT(ret);
  WideCharToMultiByte(codepage, 0, str, -1, ret, len, 0, 0);

  return ret;
}

static void Uni2AnsiBuff(LPCWSTR str1, LPSTR str2, int str2len)
{
  UINT codepage = CP_OEMCP;

  OthHookCodePage(&codepage);

  WideCharToMultiByte(codepage, 0, str1, -1, str2, str2len, 0, 0);
}

static void FreeAnsi(LPSTR str)
{
  free(str);
}

static LPWSTR Ansi2Uni(LPCSTR str)
{
  UINT codepage = CP_OEMCP;
  int len;
  LPWSTR ret;

  OthHookCodePage(&codepage);

  len = MultiByteToWideChar(codepage, 0, str, -1, 0, 0);
  ret = (LPWSTR)malloc(len << 1);
  OH_ASSERT(ret);
  MultiByteToWideChar(codepage, 0, str, -1, ret, len);

  return ret;
}

static void Ansi2UniBuff(LPCSTR str1, LPWSTR str2, int str2len)
{
  UINT codepage = CP_OEMCP;

  OthHookCodePage(&codepage);

  MultiByteToWideChar(codepage, 0, str1, -1, str2, str2len);
}

static void FreeUni(LPWSTR str)
{
  free(str);
}

static LPSTR ENG2JPFontName(LPCSTR ENGFontName)
{
  int i;

  if (ENGFontName == NULL)
    return NULL;

  for (i = 0; i < JPEngFontsLen; i++)
  {
    if (lstrcmpA(JPENGFonts[i].lpENGFontName, ENGFontName) == 0)
      return JPENGFonts[i].lpJPFontName;
  }

  return NULL;
}

static LPSTR JP2ENGFontName(LPCSTR JPFontName)
{
  int i;

  if (JPFontName == NULL)
    return NULL;

  for (i = 0; i < JPEngFontsLen; i++)
  {
    if (lstrcmpA(JPENGFonts[i].lpJPFontName, JPFontName) == 0)
      return JPENGFonts[i].lpENGFontName;
  }

  return NULL;
}

int OthTxtHookInit(HINSTANCE hInst)
{
  int i;
  int ret;
  HOOKITEM *hitem;
  HMODULE hmod;

  hmod = (HMODULE)hInst;

  for (i = 0, hitem = HookList; i < HookListLen; i++, hitem++)
  {
    hitem->pfnOrgFunc =
      (PVOID)GetProcAddress(GetModuleHandleA(hitem->lpDllName),
        hitem->lpOrgFuncName);
    OH_ASSERT(hitem->pfnOrgFunc != NULL);
  }

  OthHookInit(NULL);

  for (i = 0, hitem = HookList; i < HookListLen; i++, hitem++)
  {
    ret =
      OthHookInAllMods(hitem->lpDllName, hitem->pfnOrgFunc, hitem->pfnNewFunc,
        hmod);
    OH_ASSERT(ret == 0);
  }

  return ret;
}

