#include <windows.h>
#include <malloc.h>

#include "oh_dlinj.h"
#include "oh_debug.h"
#include "oh_fs.h"
#include "elirt.h"

typedef DWORD (WINAPI *PTHREAD_START_ROUTINE)(PVOID pvParam);

static BOOL WINAPI InjectLibW(DWORD dwProcessId, PWSTR pszLibFile);
static BOOL WINAPI InjectLibA(DWORD dwProcessId, PSTR pszLibFile);

static BOOL WINAPI InjectLibW(DWORD dwProcessId, PWSTR pszLibFile)
{
  BOOL fOk = FALSE;
  HANDLE hProcess = NULL, hThread = NULL;
  PWSTR pszLibFileRemote = NULL;
  int cch, cb;
  PTHREAD_START_ROUTINE pfnThreadRtn;

  hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_VM_OPERATION |
    PROCESS_VM_WRITE, FALSE, dwProcessId);
  if (hProcess == NULL)
    goto finishreturn;

  cch = 1 + lstrlenW(pszLibFile);
  cb  = cch * sizeof(WCHAR);

  pszLibFileRemote = (PWSTR)
    xVirtualAllocEx(hProcess, NULL, cb, MEM_COMMIT, PAGE_READWRITE);
  if (pszLibFileRemote == NULL)
    goto finishreturn;

  if (!WriteProcessMemory(hProcess, pszLibFileRemote, (PVOID)pszLibFile, cb,
    NULL))
    goto finishreturn;

  pfnThreadRtn = (PTHREAD_START_ROUTINE)
    GetProcAddress(GetModuleHandle(TEXT("Kernel32")), "LoadLibraryW");
  if (pfnThreadRtn == NULL)
    goto finishreturn;

  hThread = xCreateRemoteThread(hProcess, NULL, 0, pfnThreadRtn,
    pszLibFileRemote, 0, NULL);
  if (hThread == NULL)
    goto finishreturn;

  WaitForSingleObject(hThread, INFINITE);

  fOk = TRUE;

finishreturn:
  if (pszLibFileRemote != NULL)
    xVirtualFreeEx(hProcess, pszLibFileRemote, 0, MEM_RELEASE);

  if (hThread  != NULL)
    CloseHandle(hThread);

  if (hProcess != NULL)
    CloseHandle(hProcess);

  return(fOk);
}

static BOOL WINAPI InjectLibA(DWORD dwProcessId, PSTR pszLibFile)
{
  int len;
  PWSTR pszLibFileW;

  len = MultiByteToWideChar(CP_OEMCP, 0, pszLibFile, -1, 0, 0);
  pszLibFileW = _alloca((len + 1) << 1);
  MultiByteToWideChar(CP_OEMCP, 0, pszLibFile, -1, pszLibFileW, len + 1);

  return(InjectLibW(dwProcessId, pszLibFileW));
}

oh_int oh_di_injectDLLPID(DWORD pid, LPCTSTR dllfile)
{
  DWORD ret;
  TCHAR modfile[OH_FS_MAXPATHLEN];
  TCHAR *basemodfile;

  ret =
    SearchPath(NULL, dllfile, NULL, OH_FS_MAXPATHLEN, modfile, &basemodfile);
  OH_ASSERT(ret != 0);

#ifdef UNICODE
  InjectLibW(pid, modfile);
#else /* UNICODE */
  InjectLibA(pid, modfile);
#endif /* UNICODE */

  return 0;
}

