
/**
 * @file oh_ver.h
 * @version $Id$
 *
 * The header file that has the version information functions.
 */

#ifndef _OH_VER_H_
#define _OH_VER_H_

#include "oh_port.h"

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

/**
 * The enum of the version information.
 */
typedef enum oh_vr_item_t
{
  /**
   * The application title.
   */
  OH_VR_TITLE = 0,

  /**
   * The application version.
   */
  OH_VR_VERSION = 1,

  /**
   * The application license.
   */
  OH_VR_LICENSE = 2,

  /**
   * The application author.
   */
  OH_VR_AUTHOR = 3,

  /**
   * The application author's email address.
   */
  OH_VR_EMAIL = 4,

  /**
   * The homepage address of the application.
   */
  OH_VR_HOMEPAGE = 5,

  /**
   * The application build date.
   */
  OH_VR_DATE = 6
} oh_vr_item_t;

extern const oh_char *oh_vr_getInfo(oh_vr_item_t item);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _OH_VER_H_ */
