
/**
 * @file oh_envnm.c
 * @version $Id$
 *
 * The source file that has environment variable name functions.
 */

#include "oh_port.h"
#include "oh_envnm.h"
#include "oh_debug.h"

#define _OH_DEF2STR_WRAP(def) #def
#define _OH_DEF2STR(def) _OH_DEF2STR_WRAP(def)

static const oh_char * const _oh_en_envNames[] =
  {
    _OH_DEF2STR(OH_PROJECT) "_home",
    _OH_DEF2STR(OH_PROJECT) ".cfg"
  };

/**
 * Returns the char string of the environment variable name that is
 * corresponding to the enum of the environment variable name.
 *
 * The returned string usually depends on the current project name, OH_PROJECT.
 *
 * @param item The enum of the environment variable name.
 * @return The char string of the environment variable name.
 */
const oh_char *oh_en_getEnvName(oh_en_item_t item)
{
  OH_ASSERT(sizeof(_oh_en_envNames) / sizeof(oh_char *) > item);
  return _oh_en_envNames[item];
}
