
/**
 * @file oh_ver.c
 * @version $Id$
 *
 * The source file that has the version information functions.
 */

#include "oh_port.h"
#include "oh_debug.h"
#include "oh_ver.h"
#include "oh_veri.c"

/**
 * Returns the char string of the version information that is corresponding to
 * the enum of the version information.
 *
 * The version information is defined in the oh_veri.h that is generated in the
 * compile time.
 *
 * @param item The enum of the version information.
 * @return The char string of the version information.
 */
const oh_char *oh_vr_getInfo(oh_vr_item_t item)
{
  OH_ASSERT(sizeof(_oh_vr_infos) / sizeof(oh_char *) > item);
  return _oh_vr_infos[item];
}
